#!/usr/local/bin/perl
###############################################################
#
# Skinny Cart
# by Paul R Ryan Copyright Jan 2004  info@mujik.com
# Version 2
#
# with thanks to the Shopping Cart script by Leif M. Wright
# http://www.conservatives.net/atheist/scripts/ - much of the 
# original script started with this file. 
# Thanks also to cyberspace.org and the GREZ organisation for  
# allowing me to debug this script on a SunOs and, of course, 
# to my hosts at Linuxwebhosts in Boston for being
#  reasonable about developing PERL on commercial servers.
# A last thanks to Skinnyfish Music, for who this cart is 
# 'named'. They paid the bucks 
# for the original implementation/insipiration.
# 
##############################################################
# 
# This program is free software; you can redistribute it 
# and/or modify it under the terms of the GNU General Public 
# License as published by the Free Software Foundation; either
# version 2 of the License, or (at your option) any later 
# version.
#
# This program is distributed in the hope that it will be 
# useful, but WITHOUT ANY WARRANTY; without even the implied 
# warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR 
# PURPOSE.  
# See the GNU General Public License for more details.
# You should have received a copy of the GNU General Public 
# License (GPL) along with this program. if not, write to the 
# Free Software Foundation, Inc., 
# 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
#
# Distribute - Don't sell.
# Make money by customising for clients !
# Any enhancements can be mailed to code@mujik.com and, with a
# bit of moderation, may be included in the next version,
#
##############################################################
#
#  Skinny cart is a 'freeware' program that allows you 
# to use a "shopping" cart on your site with relatively
# little pain.It currently uses an e-mail interface - 
# that is, all orders are sent via email. All client data 
# (until they choose to 'checkout') remains on the client  
# machine. There is no 'server-side' storing of the data.
#
#    Skinny Cart is as secure as you make it.. What this means
# is there is that the script itself can run over SSL 
# (see the help files) or as plain text. It will be up to how 
# you implement it and as such, by using this script, you  
# agree that it's not my fault if something gets intercepted.
# Period.
#.
#
##############################################################
# 
#   NOTE!!!!! Skinny Cart REQUIRES Matt Wright's "cookie.lib,"
#  which I have included in with the distribution zip".
#  If this file is missing or damaged,
#  you can get Matt's "cookie.lib at: 
#  http://www.scriptarchive.com/cookielib.html 
#     
#
##############################################################
#######################  HTML CONFIGURATION  #################
##############################################################
#  This cart uses regular form inputs from your html pages. 
# The html configuration is explained in depth in the
#  distribution 'help' files but for completeness, the 
# basic settings are covered here. Each form input must have  
# the following fields (in the same order !):
#
# <form action=$scripturl method=POST> 
##(this tells the browser where to find the script)                         
#
# <input type=hidden name=action value=AddItem> 
##(this tells the script that we're adding something to 
## the order)
#                                                                                                  
# Qty: <input type=text name=quantity size=3>
## (this allows the user to select how many of each item 
## they want)
#
#Product:<input type=hidden name=product value="Product_Name">
## (This can be a product type or an artist name or a 
## manufacturer - up to you. The idea is that an order system
## will have lots of uses and it is probably better to have  
## too many fields rather than have to code extra. This is a 
## hidden field, so you can use a default if you   
##  don't need the functionality
#                                                                                                       
#Item: <input type=hidden name=item value="Your_Product"> 
## (this tells the script which item the user is ordering)
#                                                                                                  
#Catelogue Number: <input type=hidden name=id value="FM132WS">
## (It should be obvious - the unique id for the item -
## usually this would be a catelogue number
#                                                                                                       
#Price: AU$14.20 <input type=hidden name=price value=14.20>
## (This is an important field as it is used to calculate each
## customers running total on the 'checkout' screens. Use the 
## standard dollar/cents format (ie: 00.00).
#
#<input type="hidden" name="weight" value="0.5">
## (This is important for the freight calculations. It is a
## hidden field and is calculated as kilograms. Obviously,
## you need to include this for every item - don't forget to
## add the weight of the packaging. Here a sample value of
## half a kilogram (0.5) is used
#
# <input type=submit value="Order">        
## (this is the submit button that has to appear at the bottom
## of any form)
# </form>
## (this tells the browser that the form is done).
#
##See the inlcuded help.html pages for more details
#
##################  END HTML CONFIGURATION  ##################
##############################################################
#
##############################################################
#############  SKINNY CART SCRIPT CONFIGURATION  #############
##############################################################
# 
# the variables you need to set for this script to work are 
#defined below.

$mailprog = "/usr/lib/sendmail";
##$mailprog tells the script where to find your server's mail 
##programif you're unsure where it is, contact your system 
##administrator. This is a 'must' for this program - if you 
#don't have sendmail, good luck ...
##Default is "/usr/lib/sendmail" - which seems to work fine  
##with most variants of Unix/Linux

$cust_mail_sw = 1;
## $cust_mail_sw tells the program whether to send a copy of  
## any emails to the USER when theyhave ordered items. This 
## is used in the "cust_mail" subroutine, which is called
##  in the 'checkout' form. Default is 'On' but you might have
## some reason not to want this to happen
## 0=no, 1=yes.

$cartmail = "scart\@yourdomain.com";
## Is the cart's email address. This is the default mail for 
## the script and as such is used constantly throughout the
## program. Put the 'administrator' contact - that is, the   
## email you want script errors, help requests etc to be sent
## to. Skinny Cart can generate a variety of Error codes - 
## dependant on the problemMake sure you read the help files
## for more information. 'Buy' mails DO NOT get sent here
##  - use the $buymail field for that address.
## If you use perl5 or better, you'll need to put a slash (\)
##  before the @ sign.(ie: my\@email.com)

$buymail =$cartmail;
## buymail is the bean counters email - that is, the person 
## who is actually going to process the order. This may not   
##  necessarily be the person who is administrating the 
## script, so this option is included. The default is 
## $cartmail and if the administrator is seller, there is no 
## need to change it. Again, if you use perl5 or better you'll
## need to put a slash (\) before the @ sign 
## (ie: my\@email.com)

$buymail_sw = 1;
## $buymail_sw tells the program whether to send email to the
## bean counter when someone orders. Since there's no reason
##  to have a ordering system unless you can get the order,
## you should leave this value alone. Why is it here ? - 
## Good for debugging purposes and who knows, you 
## mightn't want mails (this is switched off for my demo page)
## 0=no, 1=yes. (default is 1)

$frommail = $cartmail;
## $frommail is the address you want to appear on emails you 
## send to the user. This address will appear in 
## the "from" portion of that email. Usually, it should be
## the same as the $cartmail value, but in rare cases, you may
## want to put a different value here, so I gave you the 
## ability. For most purposes, the default will be fine

$scripturl = "http://www.yourdomain.com/cgi-bin/scart.cgi";
## $scripturl is, obviously, the local url for this script. 
## You can use a path but the is no problem with the 'full'
## url. 

$shopfront = "http://www.yourdomain.com/scart/demo.html";
## $shopfront was added 19 Dec 2001 to fix a bug with the 
## 'delete item' page returning url (bad loop). 
## This sets the return to the shopfront home page and is used
## in the HTML forms as a "go back to shopfront" type button.

$usefreight = "1";
##

$ccost = "10.00";

$pcost = "5.00";

$pucost = "0.00";

$autoadd= "0";
## This is a switch between automatically returning a customer
## to the 'buy' page or to send them to a confirmation screen 
## - the script accomodates either.
## 0 is off (a confirmation screen is shown)
## 1 is on  (the user is returned to the original screen using
## the jscript "history.go (1)"; call. Default is 0 (off) 

$website="http://www.yourdomain.com";
## $website added 20 Dec 2001 to access the home page of the
## site. Again, this is used in the HTML forms in
## a "go back to homepage" button.

$tcolor="#99CCFF";
## table color

$pcolor="#FFFFFF";
## page background color

$fcolor="#000000";
## font color

$h2colour="#000000";
## H2 Header color

$h3colour="#000000";
## H3 color

$domainname = "www.yourdomain.com";
## $domainname added 15 Dec 2002 to give a site url (without
## the http://). This is used in the HTML forms
##  where a print out of the site name is required


$date_command = "/bin/date";
## Gives the date. This is off the server so it will be local
## time to that machine - if you want to set it up for your
## local time zone, have a look at the /bin/date parameters


$titlebar="The Skinny Cart";
## $titlebar is the name of the cart - used in the <title>
## </title> field for HTML4.0 browsers. This is a
## customisation to allow each page to have your text
## logo there :)


$company="Arwana Design";
## $company was added 15 Dec 2002 to allow to put an Company
##  name on the HTML forms 


$pagehead=$titlebar;
## $pagehead is another config thing - a standard "banner" for
## each page in the cart.Easiest way is to have 
## both $titlebar and $pagehead to be the same - but you can
## have them different if you want :).

$footer="You are using the Famous Skinny Cart !!";
## Again, this is a HTML layout thing - this shows up on the
## bottom of HTML forms and is a good place to put you 
## contact details, business accreditations etc.


require 'cookie.lib';
## As mentioned at the start, Matt Wright's "cookie.lib" is 
## needed for this cart.this parameter sets the cookie.lib  
## path andshould be left alone, unless you put "cookie.lib"  
## in a directory other than the same directory as the script
## (although I can't see why you would do that.) If you do, 
## this needs to tell the directory where the script is.You 
## shouldn't have to configure "cookie.lib" at all. It should
## work just as it is. Permissions are 755.


###############  YOU'RE DONE! CONGRATULATIONS!  ##############
##############################################################

##############################################################
##################  SKINNY CART PROGRAM  #####################
##############################################################

# The script starts here. Don't change anything unless you 
#know what you are doing.

#Main() 

# Do a bit of housekeeping - the first 'call' parses the input
# from your html form
&parse_input;

#The next call formats "date" field on dynamic pages and 
#emails.
 
$date = `$date_command +"%a, %d , %y"`; chop($date);

#This last bit collects the url where the browser has just
#come from
$referer = $ENV{'HTTP_REFERER'};

#The rest tests the 'Action Value' field of the input - 
#deciding which sub-routine the script needs to call next.
 
if($contents{'action'} eq "AddItem") {
&Add_Item;
}

elsif($contents{'action'} eq "DeleteItem") {
&Delete_Item;
}

elsif($contents{'action'} eq "ViewCart") {
&View_Cart;
}

elsif($contents{'action'} eq "Ccart") {
&Clear_Cart;
}

elsif($contents{'action'} eq "Ccust") {
&Clear_Cust;
}

elsif($contents{'action'} eq "MailIt") {
&Mail_It;
}

elsif($contents{'action'} eq "PrintIt") {
&Print_It;
}

elsif($contents{'action'} eq "CheckOut") {
&Check_Out;
}

## END Main()
#
##############################################################
##################  SUB ROUTINE CLEAR_CART  ##################


sub Clear_Cart{
if(&GetCookies('scart')){
#if(&Cookies('scart')){
	print "Content-type: text/html \n";
	&SetCookies('scart', "");
	print "\n";
	print "<HTML><head></head><title>$titlebar - \n";
	print "Cart Cleared</title>\n";
	print "<body bgcolor=$pcolor font=$fcolor><center>\n";
	print "<table border =0 width=\"90%\" align=center>\n";
	print "<tr bgcolor=$tcolor><td align=center>\n";
	print "<hr width=\"100%\" noshade>\n";
	print "<font color=$h2colour><H2>$pagehead</H2>\n";
	print "</font><hr width=\"100%\" noshade></td></tr>\n";
	print "<tr><td align=center><font color=$h3colour><H3>CART CLEARED\n";
	print "</H3></font><br><font color=red size=+1>\n";
	print "<i><strong>Your Cart is Now Empty</strong>\n";
	print "</i></font><font color=$h3colour><H3>\n";
	print "Thank you for using the $company $titlebar</H3>\n";
	print "</font></td></tr><tr><td>\n";
	print "<table border=0 width=\"100%\" align=center><tr><td>\n";
	print "<strong><center>You will need to close your \n";
	print "browser to totally 'eliminate' the cookie \n";
	print "but it now contains no data.</strong></center>\n";
	print "<hr noshade width=\"100%\"></td></tr></table>\n";
	print "</td></tr><tr><td align=center>If you have experienced \n";
	print "problems with our orders system  please mail \n";
	print "us at<a href=\"mailto:$frommail\?subject=Cart \n";
	print "Problems\"><strong>$frommail</strong>\n";
	print "</a></font><BR><font color=$h3colour>\n";
	print "<H3>Thank you for your support.</H3></font>\n";
	print "</center></td></tr><tr><td align=center>\n";
	print "<table border=0 COLS=2 width= \"100%\" \n";
	print "align=center bgcolor=$tcolor cellspacing=0>\n";
	print "<tr><td colspan=4><hr width=\"100%\">\n";
	print "</td></tr><tr><td align=center>\n";
	print "<a href=$shopfront><font size=-1><strong> \n";
	print "RETURN TO SHOPFRONT </strong></font></a>\n";
	print "</td></tr><tr><td colspan=2>\n";
	print "<hr width=\"100%\"></td></tr></table></center>\n";
	print "</td></tr><tr><td>\n";
	print "<table border=0 width=\"100%\"><tr>\n";
	print "<td align=center><font size=-1>\n";
	print "<strong><i><br> proudly brought to \n";
	print "you by : </i></strong></font><a href=$website>\n";
	print "<font size=-1><strong><i> $domainname</i>\n";
	print "</strong></font></a></td></tr><tr>\n";
	print "<td align=center><center><font size=-1>$footer\n";
	print "</font></center><hr width=\"100%\" noshade></td>\n";
	print "</tr></table></center></td></tr></table>\n";
	print "</center></body></html>\n";
	exit;
}else
	{
	print "Content-type: text/html \n\n";
	print "<HTML><head></head><title>$titlebar - \n";
	print "Clear Cookies Error</title>\n";
	print "<body bgcolor=$pcolor font=$fcolor><center>\n";
	print "<table border =0 width=\"90%\" align=center>\n";
	print "<tr bgcolor=$tcolor><td align=center>\n";
	print "<hr width=\"100%\" noshade>\n";
	print "<font color=$h2colour><H2>$pagehead</H2>\n";
	print "</font><hr width=\"100%\" noshade></td></tr>\n";
	print "</td></tr><tr><td>\n";
	print "<font color=$h3colour><center><H3>NO CART \n";
	print "EXISTS</center></H3></font> \n";
	print "<font color=$h3colour><center><H3>Thank you for using \n";
	print "the $company $titlebar</H3></center></font>\n";
	print "</td></tr><tr><td>\n";
	print "<table border=0 width=\"100%\"><tr>\n";
	print "<td align=center>\n";
	print "<font color=red>Clear Error:<i>You \n";
	print "either do not have a cart or your cart is \n";
	print "already empty<br><center>You might need to close your \n";
	print "browser to totally 'eliminate' the cookie\n";
	print "<br>but it now contains no data.</font></center>\n";
	print "<hr noshade size=1></td></tr></table>\n";
	print "</td></tr><tr><td>\n";
	print "<center>If you have experienced problems with our \n";
	print "orders system<br>Please mail us at \n";
	print "<a href=\"mailto:$frommail\?subject=Cart \n";
	print "Problems\"><strong>$frommail</strong></a></font>\n";
	print "<BR><font color=$h3colour><H3>Thank you for your \n";
	print "support.</H3></center></font></center>\n";
	print "</td></tr><tr><td>\n";
	print "<table border=0 COLS=2 width= \"100%\"\n";
	print "align=center bgcolor=$tcolor cellspacing=0>\n";
	print "<tr><td colspan=2><hr width=\"100%\"></td></tr>\n";
	print "<tr><td align=center><a href=$shopfront>\n";
	print "<font size=-1><strong> BACK TO SHOPFRONT \n";
	print "</strong></font></a></td><td align=center>\n";
	print "<a href=$website><font size=-1><strong> RETURN \n";
	print "TO SITE </strong></font></a></td></tr><tr>\n";
	print "<td colspan=2><hr width=\"100%\"></td></tr>\n";
	print "</table></td></tr><tr><td>\n";
	print "<table border=0 width=\"100%\">\n";
	print "<tr><td align=center><font size=-1><strong><i>\n";
	print "<br>proudly brought to you by : </i></strong>\n";
	print "</font><a href=$website><font size=-1><strong>\n";
	print "<i> $domainname</i></strong></font></a></td>\n";
	print "</tr><tr><td align=center><center><font size=-1>\n";
	print "$footer</font><hr width=\"100%\"noshade>\n";
	print "</td></tr></table>\n";
	print "</td></tr></table></center>\n";
	print "</body></html>\n";
	exit;

	}
}

## END CLEAR_CART
#
##############################################################
####################  SUB ROUTINE MAIL_IT  ###################


sub Mail_It {
if(&GetCookies('scart')){
	if(&GetCookies('cust')){
	&cart_mail;
	&cust_mail;
	print "Content-type: text/html\n";
	&SetCookieExpDate('scart','');
	&SetCookieExpDate('cust','');
	&SetCookies('scart', '');
	&SetCookies('cust', '');
	print "\n";
	
	print "<HTML><head></head><title>$titlebar - \n";
	print "Order Successful</title>\n";
	print "<body bgcolor=$pcolor font=$fcolor><center>\n";
	print "<table border =0 width=\"90%\" align=center>\n";
	print "<tr bgcolor=$tcolor><td align=center>\n";
	print "<hr width=\"100%\" noshade>\n";
	print "<font color=$h2colour><H2>$pagehead</H2></font>\n";
	print "<hr width=\"100%\" noshade></td></tr>\n";
	print "<tr><td align=center><font color=$h3colour>\n";
	print "<H3>Order sent</H3></font><br>\n";
	print "<font color=$h3colour><H3>Your order has been \n";
	print "mailed to a $company representative.</H3></font>\n";
	print "You will be contacted via the email address \n";
	print "<strong>$contents{'email'}</strong> at our \n";
	print "earliest opporunity\n";
	print "<br>If there are problems with \n";
	print "the above address or we do not get back to you \n";
	print "in a day or so <br>please mail us at \n";
	print " <a href=\"mailto:$frommail\?subject=Delayed \n";
	print "Order\"><strong>$frommail</strong>\n";
	print "</a></font><br><font color=$h3colour>\n";
	print "<H3>Thank you for your support. \n";
	print "</H3></font></CENTER>\n";
	print "</td></tr><tr><td align=center>\n";
	print "<table width=\"80%\" align=center><tr>\n";
	print "<td align=center><strong><font size=-1>\n";
	print	"<i>Note: As a security measure, all cookies \n";
	print "created by this cart were 'reset' after your \n";
	print "order was processed.<br> \n";
	print "To send further orders you will need to input \n";
	print "all Personal Details again<br>\n";
	print "Some information will be retained by your \n";
	print "browser's cache (esp. Internet Explorer).<br>\n";
	print "If you are on 'public' machine that could be\n";
	print "accessed by other users, it is suggested that \n";
	print "clear your cache and\/or close all browsers\n";
	print "before leaving the machine</i></font></strong>\n";
	print "</td></tr></table>\n";
	print "</td></tr><tr><td align=center>\n";
	print "<table width=\"100%\" border =0 bgcolor=$tcolor \n";
	print "cellspacing=0><tr><td align=center>\n";
	print "<hr width=\"100%\" noshade>\n";
	print "<a href=\"http://$domainname\">\n";
	print "<strong> BACK TO SITE </strong></a>\n";
	print "<hr width=\"100%\" noshade></td></tr></table>\n";
	print "</td></tr><tr><td align=center>\n";
	print "<table border=0 width=\"100%\"><tr>\n";
	print "<td align=center><font size=-1><strong>\n";
	print "<i> proudly brought to you by : </i></strong>\n";
	print "</font><a href=$website><font size=-1><strong>\n";
	print "<i> $domainname</i></strong></font></a></td>\n";
	print "</tr><tr><td align=center><font size=-1>$footer\n";
	print "</font><hr width=\"100%\" noshade></td></tr>\n";
	print "</table></td></tr></table></center>\n";
	print "</body></html>\n";
	exit;
}else #exception if &GetCookies('cust') fails 
	{
		print "Content-type: text/html\n\n";
		print "<HTML><head></head><title>$titlebar - \n";
		print "No Customer Data</title>\n";
		print "<body bgcolor=$pcolor font=$fcolor><center>\n";
		print "<table border =0 width=\"90%\" align=center>\n";
		print "<tr bgcolor=$tcolor><td align=center>\n";
		print "<hr width=\"100%\" noshade>\n";
		print "<font color=$h2colour><H2>$pagehead</H2>\n";
		print "</font><hr width=\"100%\" noshade>\n";
		print "</td></tr><tr><td align=center>\n";
		print "<font color=$h3colour>\n";
		print "<H3>Orders Error - No Customer Details\n";
		print "</H3></font><br><p>You should NOT be \n";
		print "seeing this screen - it means something is \n";
		print "wrong with the cookie your customer details \n";
		print "are stored in. The most likely explanation \n";
		print "is that you have followed a offsite link<br>\n";
		print "If this is not the case and you \n";
		print "are sure you completed your customer details, \n";
		print "have  not closed your browser and have not \n";
		print "recently logged out or sent an order <strong>\n";
		print "contact <a href=\"mailto:$cartmail\?subject=\n";
		print "Customer Cookies Error\">\n";
		print "$cartmail</a> immediately</strong>\n";
		print "</td></tr><tr><td align=center>\n";
		print "<table width=\"100%\" border =0 bgcolor=$tcolor \n";
		print "cellspacing=0><tr><td align=center>\n";
		print "<hr width=\"100%\" noshade>\n";
		print "<a href=\"http://$domainname\"><font size=-1>\n";
		print "<strong> BACK TO SITE </strong></font></a>\n";
		print "<hr width=\"100%\" noshade></td></tr></table>\n";
		print "</td></tr><tr><td align=center>\n";
		print "<table border=0 width=\"100%\" \n";
		print "colspacing=0 align=center>\n";
		print "<tr><td align=center><hr width=\"100%\">\n";
		print "<font size=-1><strong><i><br>proudly \n";
		print "brought to you by : </i></strong></font>\n";
		print "<a href=$website><font size=-1><strong>\n";
		print "<i>$domainname</i></strong></font></a>\n";
		print "</td></tr><tr><td align=center><font size=-1>\n";
		print "$footer</font><hr width=\"100%\" noshade>\n";
		print "</td></tr></table></td></tr>\n";
		print "</table></center>\n";
		print "</body></html>\n";
		exit;
	}
}else  #exception if &GetCookies('scart') fails - again, unlikely but ..
	{
		print "Content-type: text/html\n\n";
		print "<HTML><head></head><title>$titlebar\n";
		print " - Empty Cart</title>\n";
		print "<body bgcolor=$pcolor font=$fcolor><center>\n";
		print "<table border =0 width=\"90%\" align=center>\n";
		print "<tr bgcolor=$tcolor><td align=center>\n";
		print "<hr width=\"100%\" noshade>\n";
		print "<font color=$h2colour><H2>$pagehead</H2>\n";
		print "</font><hr width=\"100%\" noshade></td></tr>\n";
		print "<tr><td align=center><font color=$h3colour>\n";
		print "<H3>Orders Error - Empty Cart</H3></font>\n";
		print "You can't send an order if your cart is \n";
		print "empty !<br> <font color=$h3colour><H3>Please \n";
		print "try again</H3></font><br>If you believe that \n";
		print "you should not have arrived at this page,\n";
		print "<br>please email us at \n";
		print "<a href=\"mailto:$cartmail\?subject=Empty Cart\">\n";
		print " $cartmail</a> immediately</font>\n"; 
		print "<p>Thank You for your Interest !</p>\n";
		print "</td></tr><tr><td align=center>\n";	
		print "<table width=\"100%\" bgcolor=$tcolor>\n";
		print "<tr><td align=center>\n";
		print "<hr width=\"100%\" noshade>\n";
		print "<a href=\"http://$domainname\"><font size=-1>\n";
		print "<strong> BACK TO SITE </strong></font></a>\n";
		print "<hr width=\"100%\" noshade></td></tr></table>\n";
		print "</td></tr><tr><td align=center>\n";
		print "<table border=0 width=\"100%\" align=center>\n";
		print "<tr><td align=center><font size=-1>\n";
		print "<strong><i> proudly brought to you by : </i>\n";
		print "</strong></font><a href=$website>\n";
		print "<font size=-1><strong><i> $domainname</i>\n";
		print "</strong></font></a></td></tr><tr>\n";
		print "<td align=center><font size=-1>\n";
		print "$footer</font><hr width=\"100%\" noshade>\n";
		print "</td></tr></table>\n";
		print "</td></tr></table></center>\n";
		print "</body></html>\n";
		exit;
	}
}

## END MAIL_IT
#
##############################################################
###################  SUB ROUTINE CART_MAIL ###################
# sends email to $cartmail (you) informing you that someone 
#has used this script. IF you don't want email, set the 
#me_mail value to 0.

sub cart_mail{

if($buymail_sw == '1') {
	if(&GetCookies('scart')){
		if(&GetCookies('cust')){

	my	@custd = split(/\|/, $Cookies{'cust'});
	
	foreach $custd(@custd)
	{
	($cfname,$clname,$csaddress,$ccity,$cstate,$cpcode,$cnation,$cemail,$cftype,$cptype,$ccomment) = split(/:/ , $custd);
	}  #end loop
	
	open (MAIL, "|$mailprog -t")  || die "Can't open $mailprog!\n";
	print MAIL "To: $buymail\n";
	print MAIL "From: $cemail\n";
	print MAIL "Subject:New $company Order\n\n";
	print MAIL "$cfname $clname used your ordering system\n\n";
	print MAIL "The details are:\n";
	print MAIL "\n$cfname $clname\n";
	print MAIL "$cemail\n\n";
	print MAIL "$csaddress\n\n";
	print MAIL "$ccity, $cstate $cpcode\n\n";
	print MAIL "$cnation\n\n";
	print MAIL "\n\nTheir Order is:\n\n";

	my	@msg = split(/\|/, $Cookies{'scart'});
	$tweight=0;
	$full_charge=0;
	$count=0;
	$Total=0;
	foreach $msg (@msg){
		($mquantity, $mproduct, $mitem, $mid, $mprice, $mweight) = split(/:/ , $msg);
		if($mproduct){
			print MAIL "$mquantity $mproduct, $mitem, $mid at \$$mprice each\n";
			my $SubTotal = $mquantity * $mprice;
			my $SubWeight= $mweight * $mquantity;
			$Total = $Total + $SubTotal;
			$count = $count + $mquantity;
			$tweight = $tweight + $SubWeight;
		} #end if
	} #end loop
	
	if($usefreight eq "1"){
		if($cftype eq 'Courier'){
			$fcharge=($tweight * $ccost);
		}
		elsif($cftype eq 'Post'){
			$fcharge=($tweight * $pcost);
		}
		elsif($cftype eq 'Pick Up'){
			$fcharge=($tweight * $pucost);
		}
 
	$full_charge=$fcharge + $Total;
	print MAIL "$cfname selected $cftype delivery\n";
	print MAIL "Total Weight is $tweight kg with a cost of \$$fcharge\n";
	print MAIL "Total: $count items for \$$full_charge\n";
	}else{
	print MAIL "\nTotal: $count items for \$$Total\n";
	}
	if($cptype eq Credit){
	print MAIL "$cptype Card was selected with the following details:\n";
	print MAIL "Card Issuer: $contents{'cc_type'}\n";
	print MAIL "Name: $contents{'cc_name'}\n";
	print MAIL "Number: $contents{'cc_number'}\n";
	print MAIL "Key: $contents{'cc_valid'}\n";	
	print MAIL "Expires: $contents{'cc_exp'}\n";	
	}else{
	print MAIL "\nPayment selected was $cptype\n";	
}
	print MAIL "\nThe Customer made the following comment:\n";
	print MAIL "\n$ccomment\n";
	print MAIL "\nThis mail was sent on $date\n";
	close (MAIL);

}else #exception if the &GetCookies('cust') fails
	{
		print "Content-type: text/html\n\n";
		print "<html><head></head><title>$pagehead - \n";
		print "Customer Cookie Error !</title>\n";
		print "<body bgcolor=$pcolor font=$fcolor><center>\n";
		print "<table border =0 width=\"90%\" align=center>\n";
		print "<tr bgcolor=$tcolor><td align=center>\n";
		print "<hr width=\"100%\" noshade>\n";
		print "<font color=$h2colour><H2>$pagehead</H2>\n";
		print "</font><hr width=\"100%\" noshade></td></tr>\n";
		print "<tr><td><font color=$h3colour><H3>Your \n";
		print "Personal Details were invalid</H3></font> \n";
		print "Please hit your browsers return (back) \n";
		print "button </a> and complete all fields\n";
		print "<br>If you believe that you should not have \n";
		print "arrived at this page,<br>please email us at \n";
		print "<a href=\"mailto:$cartmail\?subject=No Personal Details\">\n";
		print " $cartmail</a> immediately</font>\n"; 
		print "<br>Thank You for your Interest !\n";
		print "</td></tr><tr><td>\n";
		print "<table border=0 COLS=3 width= \"100%\" \n";
		print "align=center bgcolor=$tcolor cellspacing=0>\n";
		print "<tr><td colspan=3><hr width=\"100%\"></td>\n";
		print "</tr><tr align=center>\n";
		print "<td align=right><a href=$shopfront>\n";
		print "<font size=-1><strong> CONTINUE BROWSING\n";
		print "</strong></font></a></td><td align=center>\n";
		print "<a href=$scripturl\?action=Ccart>\n";
		print "<font size=-1><strong> CLEAR CART </strong>\n";
		print "</font></a></td><td align=left>\n";
		print "<a href=$scripturl\?action=CheckOut>\n";
		print "<font size=-1><strong> CHECK OUT \n";
		print "</strong></font></a></td></tr><tr>\n";
		print "<td colspan=3><hr width=\"100%\">\n";
		print "</td></tr></table></td></tr><tr><td>\n";
		print "<table border=0 width=\"90%\"><tr>\n";
		print "<td align=center><font size=-1><strong>\n";
		print "<i> proudly brought to you by : </i></strong>\n";
		print "</font><a href=$website><font size=-1>\n";
		print "<strong><i> $domainname</i></strong></font>\n";
		print "</a></td></tr><tr><td align=center>\n";
		print "<font size=-1>$footer</font>\n";
		print "<hr width=\"100%\" noshade></td></tr>\n";
		print "</table></td></tr></table></center>\n";
		print "</body></html>\n";
		exit;
	}
}else  #exception if the &GetCookies('scart') fails
	{
		print "Content-type: text/html\n\n";
		print "<html><head></head><title>$pagehead - \n";
		print "Cart Cookie Error !</title>\n";
		print "<body bgcolor=$pcolor font=$fcolor><center>\n";
		print "<table border =0 width=\"90%\" align=center>\n";
		print "<tr bgcolor=$tcolor><td align=center>\n";
		print "<hr width=\"100%\" noshade>\n";
		print "<font color=$h2colour><H2>$pagehead</H2>\n";
		print "</font><hr width=\"100%\" noshade></td></tr>\n";
		print "<tr><td><center><font color=$h3colour><H3>\n";
		print "No Cart Error!</H3></font>\n";
		print "<hr width=\"100%\"><strong>You can't check \n";
		print "out, because you have not ordered any items\n";
		print "</strong><hr width=\"100%\"><br> If you \n";
		print "believe that you should not have arrived at \n";
		print "this page,<br>please email us at \n";
		print "<a href=\"mailto:$cartmail\?subject=No Cart\">\n";
		print "$cartmail</a> immediately</font>\n"; 
		print "<br>Thank You for your Interest !\n";
		print "</td></tr><tr><td>\n";
		print "<table border=0 COLS=3 width= \"100%\" \n";
		print "align=center bgcolor=$tcolor cellspacing=0>\n";
		print "<tr><td colspan=3><hr width=\"100%\">\n";
		print "</td></tr><tr align=center>\n";
		print "<td align=right><a href=$shopfront>\n";
		print "<font size=-1><strong> CONTINUE BROWSING\n";
		print "</strong></font></a></td><td align=center>\n";
		print "<a href=$scripturl\?action=Ccart>\n";
		print "<font size=-1><strong> CLEAR CART </strong>\n";
		print "</font></a></td><td align=left>\n";
		print "<a href=$scripturl\?action=CheckOut>\n";
		print "<font size=-1><strong> CHECK OUT </strong>\n";
		print "</font></a></td>\n";
		print "</tr><tr><td colspan=3><hr width=\"100%\">\n";
		print "</td></tr></table></td></tr><tr><td>\n";
		print "<table border=0 width=\"100%\"><tr>\n";
		print "<td align=center><font size=-1>\n";
		print "<strong><i> proudly brought to you by : \n";
		print "</i></strong></font>\n";
		print "<a href=$website><font size=-1><strong><i> \n";
		print "$domainname</i></strong></font></a></td></tr>\n";
		print "<tr><td align=center><font size=-1>$footer\n";
		print "</font><hr width=\"100%\" noshade></td></tr>\n";
		print "</table></td></tr></table></center>\n";
		print "</body></html>\n";
		exit;
	}
} #exception if the $buymail_sw == '1' fails
}

## END CART_MAIL
#
##############################################################
##################### SUB ROUTINE CUST_MAIL ##################
# This sends email to the client - with a copy of their order.

sub cust_mail {
	
if(&GetCookies('scart')) {
	if($cust_mail_sw == 1) {
	my	@msg = split(/\|/, $Cookies{'scart'});
		if(&GetCookies('cust')){
		my	@custd = split(/\|/, $Cookies{'cust'});
	
	foreach $custd(@custd){
	($cfname,$clname,$csaddress,$ccity,$cstate,$cpcode,$cnation,$cemail,$cftype,$cptype,$ccomment) = split(/:/ , $custd);
	}  #end loop
	
	open (MAIL, "|$mailprog -t")  || die "Can't open $mailprog!\n";
	print MAIL "To: $cemail\n";
	print MAIL "From: $buymail\n";
	print MAIL "Subject: $company Order\n\n";
	print MAIL "Dear $cfname\n\n";
	print MAIL "\nThank you for your order\n";
	print MAIL "Please check the following details:\n";
	print MAIL "\nPersonal Details:\n";
	print MAIL "\n$cfname $clname\n";
	print MAIL "$cemail\n\n";
	print MAIL "$csaddress\n\n";
	print MAIL "$ccity, $cstate $cpcode\n\n";
	print MAIL "$cnation\n\n";
	print MAIL "\nYour Order details:\n\n";
	
	my	@msg = split(/\|/, $Cookies{'scart'});
	$tweight=0;
	$full_charge=0;
	$count=0;
	$Total=0;
	foreach $msg (@msg){
		($mquantity, $mproduct, $mitem, $mid, $mprice, $mweight) = split(/:/ , $msg);
		if($mquantity > 0){
			print MAIL "$mquantity $mproduct, $mitem, $mid at \$$mprice each\n";
			my $SubTotal = $mquantity * $mprice;
			my $SubWeight= $mweight * $mquantity;
			$Total = $Total + $SubTotal;
			$count = $count + $mquantity;
			$tweight = $tweight + $SubWeight;
		} #end if
	} #end loop
	
	if($usefreight eq "1"){
		if($ftype eq "Courier"){
			$fcharge=($tweight * $ccost);
		}
		elsif($ftype eq "Post"){
			$fcharge=($tweight * $pcost);
		}
		elsif($ftype eq "Pick Up"){
			$fcharge=($tweight * $pucost);
		}
 
	$full_charge=$fcharge + $Total;
	print MAIL "$cfname selected $cftype delivery\n";
	print MAIL "Total Weight is $tweight kg with a cost of \$$fcharge\n";
	print MAIL "Total: $count items for \$$full_charge\n";
	}else{
	print MAIL "\nTotal: $count items for \$$Total\n";
	}
	if($cptype eq Credit){
	print MAIL "\nPayment selected was $cptype with the following details:\n";
	print MAIL "Card Issuer: $contents{'cc_type'}\n";
	print MAIL "Name: $contents{'cc_name'}\n";
	print MAIL "Number: <hidden>\n";
	print MAIL "Key: <hidden>\n";	
	print MAIL "Expires: $contents{'cc_exp'}\n\n";	
	}else{
	print MAIL "\nPayment selected was $cptype\n";	
}
	print MAIL "\nYou made the follwoing comment:\n";
	print MAIL "\n$ccomment\n";
	print MAIL "\nIf the above order is correct, do nothing !\n\n";
	print MAIL "Our experienced Sales team will contact you shortly.\n";
	print MAIL "If the contents are wrong or you have any further queries, \n";
	print MAIL "please contact us at: $buymail\n";
	print MAIL "\nThank you for your custom !\n";
	print MAIL "\nThis mail was sent on $date\n";
	close (MAIL);
}else  #exception if the &GetCookies('cust') fails
	{
		print "Content-type: text/html\n\n";
		print "<html><head></head><title>$pagehead - \n";
		print "Customer Cookie Error !</title>\n";
		print "<body bgcolor=$pcolor font=$fcolor><center>\n";
		print "<table border =0 width=\"90%\" align=center>\n";
		print "<tr bgcolor=$tcolor><td align=center>\n";
		print "<hr width=\"100%\" noshade>\n";
		print "<font color=$h2colour><H2>$pagehead</H2>\n";
		print "</font><hr width=\"100%\" noshade></td></tr>\n";
		print "<tr><td><font color=$h3colour><H3>Your \n";
		print "Customer Details are incomplete or corrupted\n";
		print "</H3></font><br><strong><i>Make sure your \n";
		print "browser accepts'cookies', \n";
		print "<a href=\"$scripturl\?action=checkout\">\n";
		print "return to the 'Check Out'</a> page and \n";
		print "complete all fields\n";
		print "<br><font size=-1>If you have recently \n";
		print "closed your browser or\n";
		print "submitted an order, your details were \n";
		print "automatically deleted.<br><font color=red>\n";
		print "If you believe that you \n";
		print "should not have arrived at this page,<br>\n";
		print "please email us at \n";
		print "<a href=\"mailto:$cartmail\?subject=No Customer Data\">\n";
		print " $cartmail</a> immediately</font></font>\n"; 
		print "Thank You for your Interest !</strong></td></tr><tr>\n";
		print "<td><table border=0 COLS=3 width= \"100%\" \n";
		print "align=center bgcolor=$tcolor cellspacing=0>\n";
		print "<tr><td colspan=3><hr width=\"100%\"></td>\n";
		print "</tr><tr align=center>\n";
		print "<td align=right><a href=$shopfront>\n";
		print "<font size=-1><strong> CONTINUE BROWSING\n";
		print "</strong></font></a></td><td align=center>\n";
		print "<a href=$scripturl\?action=Ccart>\n";
		print "<font size=-1><strong> CLEAR CART </strong>\n";
		print "</font></a></td><td align=left>\n";
		print "<a href=$scripturl\?action=CheckOut>\n";
		print "<font size=-1><strong> CHECK OUT </strong>\n";
		print "</font></a></td></tr><tr><td colspan=3>\n";
		print "<hr width=\"100%\"></td></tr></table></td>\n";
		print "</tr><tr><td><table border=0 width=\"90%\">\n";
		print "<tr><td align=center><font size=-1><strong>\n";
		print "<i> proudly brought to you by : </i></strong>\n";
		print "</font><a href=$website><font size=-1>\n";
		print "<strong><i> $domainname</i>\n";
		print "</strong></font></a></td>\n";
		print "</tr><tr><td align=center><font size=-1>\n";
		print "$footer</font><hr width=\"100%\" noshade>\n";
		print "</td></tr></table>\n";
		print "</td></tr></table></center>\n";
		print "</body></html>\n";
		exit;	
	}
}else  #exception if the $cust_mail_sw == 1 fails
	{
		print "Content-type: text/html\n\n";
		print "<html><head></head><title>$pagehead \n";
		print "- Mail Disabled Error !</title>\n";
		print "<body bgcolor=$pcolor font=$fcolor><center>\n";
		print "<table border =0 width=\"90%\" align=center>\n";
		print "<tr bgcolor=$tcolor><td align=center>\n";
		print "<hr width=\"100%\" noshade>\n";
		print "<font color=$h2colour><H2>$pagehead</H2>\n";
		print "</font><hr width=\"100%\" noshade></td>\n";
		print "</tr><tr><td><font color=$h3colour><H3>The \n";
		print "Customer Mail service has been disabled in \n";
		print "this script</H3></font>\n";
		print "<br> If you believe that you should not have \n";
		print "arrived at this page,<br>please email us at \n";
		print "<a href=\"mailto:$cartmail\?subject=Mail Disabled\">\n";
		print " $cartmail</a> immediately</font>\n"; 
		print "Thank You for your Interest !</td></tr><tr>\n";
		print "<td><table border=0 COLS=3 align=center \n";
		print "bgcolor=$tcolor cellspacing=0>\n";
		print "<tr><td colspan=3><hr width=\"100%\"></td>\n";
		print "</tr><tr align=center>\n";
		print "<td align=right><a href=$shopfront>\n";
		print "<font size=-1><strong> CONTINUE BROWSING\n";
		print "</strong></font></a></td><td align=center>\n";
		print "<a href=$scripturl\?action=Ccart>\n";
		print "<font size=-1><strong> CLEAR CART </strong>\n";
		print "</font></a></td><td align=left>\n";
		print "<a href=$scripturl\?action=CheckOut>\n";
		print "<font size=-1><strong> CHECK OUT </strong>\n";
		print "</font></a></td></tr><tr><td colspan=3>\n";
		print "<hr width=\"100%\"></td></tr></table></td>\n";
		print "</tr><tr><td><table border=0>\n";
		print "<tr><td align=center><font size=-1>\n";
		print "<strong><i> proudly brought to you by : </i>\n";
		print "</strong></font><a href=$website>\n";
		print "<font size=-1><strong><i> $domainname</i>\n";
		print "</strong></font></a></td></tr><tr>\n";
		print "<td align=center><font size=-1>$footer</font>\n";
		print "<hr width=\"100%\" noshade></td></tr></table>\n";
		print "</td></tr></table></center>\n";
		print "</body></html>\n";
		exit;
	}
}else   #exception if the &GetCookies('scart') fails
	{
		print "Content-type: text/html\n\n";
		print "<html><head></head><title>$pagehead - \n";
		print "Empty Cart Error !</title>\n";
		print "<body bgcolor=$pcolor font=$fcolor><center>\n";
		print "<table border =0 width=\"90%\" align=center>\n";
		print "<tr bgcolor=$tcolor><td align=center>\n";
		print "<hr width=\"100%\" noshade>\n";
		print "<font color=$h2colour><H2>$pagehead</H2>\n";
		print "</font><hr width=\"100%\" noshade></td></tr>\n";
		print "<tr><td><font color=$h3colour><H3>Cart Error !\n";
		print "</H3></font><hr width=\"100%\">\n";
		print "<font color=$h3colour><strong>You can't check \n";
		print "out, as you have not ordered any items\n";
		print "</strong><hr width=\"90%\"><br>If you \n";
		print "believe that you should not have arrived at \n";
		print "this page,<br>please email us at \n";
		print "<a href=\"mailto:$cartmail\?subject=No Order \n";
		print "Error \">$cartmail</a> immediately</font>\n"; 
		print "<br>Thank You for your Interest !\n";
		print "</td></tr><tr><td>\n";
		print "<table border=0 COLS=3 width= \"100%\" \n";
		print "align=center bgcolor=$tcolor cellspacing=0>\n";
		print "<tr><td colspan=3><hr width=\"100%\"></td>\n";
		print "</tr><tr align=center>\n";
		print "<td align=right><a href=$shopfront>\n";
		print "<font size=-1><strong> CONTINUE BROWSING\n";
		print "</strong></font></a></td><td align=center>\n";
		print "<a href=$scripturl\?action=Ccart>\n";
		print "<font size=-1><strong> CLEAR CART </strong>\n";
		print "</font></a></td><td align=left>\n";
		print "<a href=$scripturl\?action=CheckOut>\n";
		print "<font size=-1><strong> CHECK OUT \n";
		print "</strong></font></a></td></tr><tr>\n";
		print "<td colspan=3><hr width=\"100%\"></td></tr>\n";
		print "</table></td></tr><tr><td>\n";
		print "<table border=0 width=\"90%\"><tr>\n";
		print "<td align=center><font size=-1><strong>\n";
		print "<i> proudly brought to you by : </i></strong>\n";
		print "</font><a href=$website><font size=-1>\n";
		print "<strong><i> $domainname</i></strong></font>\n";
		print "</a></td></tr><tr><td align=center>\n";
		print "<font size=-1>$footer\n";
		print "</font><hr width=\"90%\" noshade></td></tr>\n";
		print "</table></td></tr></table></center>\n";
		print "</body></html>\n";
		exit;
	}
}

## END CUST_MAIL
#
##############################################################
###################  SUB ROUTINE VIEW_CART  ##################

sub View_Cart {
	
if(&GetCookies('scart')){
	if($Cookies{'scart'}){
		
	$refresh="$Cookies{'scart'}";
	@all_items = split(/\|/, $refresh);
	
	print "Content-type: text/html\n";
	&SetCookies('scart',"$refresh");
	print "\n";
	print "<html><head><title>$titlebar - Orders System\n";
	print "</title></head>\n";
	print "<body bgcolor=$pcolor font=$fcolor><center>\n";
	print "<table border =0 width=\"90%\" align=center>\n";
	print "<tr bgcolor=$tcolor><td align=center>\n";
	print "<hr width=\"100%\" noshade>\n";
	print "<font color=$h2colour><H2>$pagehead\n";
	print "</H2></font><hr width=\"100%\" noshade></td>\n";
	print "</tr><tr><td align=center><font color=$h3colour>\n";
	print "<H3>Your Current Cart</H3></font><br>\n";
	print "</td></tr><tr><td align=center><br>\n";
	print "<table border=0 align=center><tr>\n";
	print "<td align=center><strong><u>Qty</u></strong>\n";
	print "</td><td align=center><strong><u>Product</u>\n";
	print "</strong></td><td align=center><strong><u>Item\n";
	print "</u></strong></td><td align=center><strong><u>ID\n";
	print "</u></strong></td><td align=center><strong>\n";
	print "<u>Price</u></strong></td><td align=center>\n";
	print "<strong><u>Action</u></strong></td></tr>\n";
	
	$RemoveNumber=0;
	$count=0;
	$Total=0;
	$tweight=0;
	
	foreach $all_items (@all_items) {
		($quantity, $product, $item, $id, $price, $weight) = split(/:/ , $all_items);
		if($quantity > 0){
			print "<tr align=center><td>  $quantity  </td>\n";
			print "<td>  $product  </td><td>  $item  </td>\n";
			print "<td>  $id  </td><td>  \$$price each  </td><td>\n";
			print "<a href=$scripturl\?action=DeleteItem\&number=$RemoveNumber>\n";
			print "<i>  Remove  </i></a></td></tr>\n";
			my $SubTotal = $quantity * $price;
			my $SubWeight= $weight * $quantity;
			$Total = $Total + $SubTotal;
			$count = $count + $quantity;
			$tweight = $tweight + $SubWeight;  
			$RemoveNumber++;
		} #end if
	} #end loop
	print "</table><br></td></tr><tr><td align=center>\n";
	print "You Have Selected <strong>\n";
	printf("%.0f",$count);
	print "</strong> items\n";
	print " for a Total of: <strong>\$ \n";
	printf("%.2f", $Total);
	print "</strong><br><br>\n";
	print "Total Weight is : <strong>\n";
	printf("%.2f", $tweight);
	print " kg </strong> <br><br><br></td></tr><tr><td>\n";
	print "<table border=0 bgcolor=$tcolor width=\"100%\" align=center cellspacing=0>\n";
	print "<tr><td colspan=3><hr width=\"100%\"></td></tr>\n";
	print "<tr align=center><td align=center>\n";
	print "<a href=$shopfront><font size=-1><strong>\n";
	print " CONTINUE </strong></font></a></td><td align=center>\n";
	print "<a href=$scripturl\?action=Ccart><font size=-1>\n";
	print "<strong> CLEAR CART </strong></font></a></font>\n";
	print "</a></td><td align=center>\n";
	print "<a href=$scripturl\?action=CheckOut>\n";
	print "<font size=-1><strong> CHECK OUT </strong></font>\n";
	print "</a></td></tr>\n";
	print "<tr><td colspan=3><hr width=\"100%\"></td></tr>\n";
	print "<tr align=center><td align=center></table></center>\n";
	print "</td></tr><tr><td>\n";	
	print "<table border=0 width=\"100%\"><tr>\n";
	print "<td align=center>\n";
	print "<font size=-1><strong><i><br>\n";
	print "proudly brought to you by : </i></strong></font>\n";
	print "<a href=$website><font size=-1><strong>\n";
	print "<i> $domainname</i></strong></font></a></td>\n";
	print "</tr><tr><td align=center><font size=-1>$footer\n";
	print "</font><hr width=\"100%\" noshade></td></tr>\n";
	print "</table></td></tr></table></center>\n";
	print "</body></html>\n";
	exit;
}else # exception if the &Cookies{'scart'} fails
	{
		print "Content-type: text/html\n\n";
		print "<html><head><title>$titlebar - \n";
		print "Empty Cart Error !\n";
		print " </title></head>\n";
		print "<body bgcolor=$pcolor font=$fcolor><center>\n";
		print "<table border =0 width=\"90%\" align=center>\n";
		print "<tr bgcolor=$tcolor><td align=center>\n";
		print "<hr width=\"100%\" noshade>\n";
		print "<font color=$h2colour><H2>$pagehead</H2>\n";
		print "</font><hr width=\"100%\" noshade>\n";
		print "</td></tr><tr><td align=center><font color=$h3colour>\n";
		print "<H3>Empty Cart Error !</H3></font>\n";
		print "<br>You can't view your cart, because it is \n";
		print "empty !<hr width=\"100%\"><br><font size=-1>\n";
		print "This ordering system uses cookies to keep \n";
		print "track of your order.<br>If you have recently \n";
		print "closed your browser, our cookie was reset and\n";
		print " you will need to replace your order.<br> \n";
		print "We apologise in advance for any inconveniance.\n";
		print "<br>If you believe that you should not have \n";
		print "arrived at this page, please email us at \n";
		print "<a href=\"mailto:$cartmail\?subject=Empty \n";
		print "Cart Error \">$cartmail</a>\n";
		print " immediately</font><br>\n";
		print "</td></tr><tr><td>\n";	
		print "<table bgcolor=$tcolor align=center width=\"100%\">\n"; 
		print "<tr><td align=center><hr width=\"100%\"><a href=$shopfront>\n";
		print "<font size=-1><strong>KEEP SHOPPING</strong>\n";
		print "</font></a><hr width=\"100%\"></center>\n";
		print "</td></tr></table>\n";
		print "</td></tr><tr><td align=center >\n";	
		print "<table border=0 width=\"100%\" align=center><tr>\n";
		print "<td align=center>\n";
		print "<font size=-1><strong><i><br>\n";
		print "proudly brought to you by : </i></strong>\n";
		print "</font><a href=$website><font size=-1>\n";
		print "<strong><i> $domainname</i></strong></font>\n";
		print "</a></td></tr><tr><td align=center>\n";
		print "<font size=-1>$footer</font>\n";
		print "<hr width=\"100%\" noshade></td></tr>\n";
		print "</table></td></tr></table></center>\n";	
		print "</body></html>\n";
		exit;
	}
}else # exception if the &GetCookies{'scart'} fails
	{
		print "Content-type: text/html\n\n";
		print "<html><head><title>$titlebar - \n";
		print "No Cart Error !\n";
		print "</title></head>\n";
		print "<body bgcolor=$pcolor font=$fcolor><center>\n";
		print "<table border =0 width=\"90%\" align=center>\n";
		print "<tr bgcolor=$tcolor><td align=center>\n";
		print "<hr width=\"100%\" noshade>\n";
		print "<font color=$h2colour><H2>$pagehead</H2>\n";
		print "</font><hr width=\"100%\" noshade></td>\n";
		print "</tr><tr><td align=center><font color=$h3colour><H3>\n";
		print "No Cart Error !</H3></font>\n";
		print "You can't view your cart, because you don't \n";
		print "have one !<hr width=\"100%\">\n";
		print "<br><font size=-1> This ordering system \n";
		print "uses cookies to keep track of your order.\n";
		print "<br>If you have recently closed your browser, \n";
		print "our cookie was reset and you will need to \n";
		print "replace your order. <br>We apologise in \n";
		print "advance for any inconveniance. \n";
		print "<br>If you believe \n";
		print "that you should not have arrived at this \n";
		print "page, please email us at \n";
		print "<a href=\"mailto:$cartmail\?subject=No Cart Error\">\n";
		print "$cartmail</a> immediately</font><br>\n";
		print "</td></tr><tr><td>\n";		
		print "<table bgcolor=$tcolor align=center width=\"100%\"><tr><td>\n";
		print "<hr width=\"100%\" noshade><a href=$referer>\n"; 
		print "<font size=-1><center><strong>RETURN</strong></center></font>\n";
		print "</a></center></td></tr></table>\n";
		print "</td></tr><tr><td>\n";	
		print "<hr width=\"100%\">\n";
		print "<table border=0 width=\"100%\" align=center><tr>\n";
		print "<td align=center>\n";
		print "<font size=-1><strong><i><br>proudly \n";
		print "brought to you by : </i></strong></font>\n";
		print "<a href=$website><font size=-1><strong>\n";
		print "<i> $domainname</i></strong></font></a></td>\n";
		print "</tr><tr><td align=center><font size=-1>\n";
		print "$footer</font><hr width=\"100%\" noshade>\n";
		print "</td></tr></table>\n";
		print "</td></tr></table></center>\n";	
		print "</body></html>\n";
		exit;
	}
}

## END VIEW_CART
#
##############################################################
##################   SUB ROUTINE CHECK_OUT  ##################

sub Check_Out {

if(&GetCookies('scart')){
#if ($Cookies{'scart'}){

	my	@all_items = split(/\|/, $Cookies{'scart'});
	
	print "Content-type: text/html\n\n";
	print "<html><head><title>$titlebar - \n";
	print "Check Out </title></head>\n";
	print "<body bgcolor=$pcolor font=$fcolor>\n";
	print "<table border=0 width=\"90%\" \n";
	print "align=center><tr bgcolor=$tcolor><td align=center>\n";
	print "<hr width=\"100%\" noshade>\n";
	print "<font color=white><font color=$h2colour>\n";
	print "<H2>$pagehead CHECK OUT <H2>\n";
	print "<hr width=\"100%\" noshade></td></tr>\n";
	print "<tr><td align=center><font size=-2><i>You may \n";
	print "need to refresh this page to get the latest \n";
	print "look at your cart.</i></font><br>\n";
	print "</td></tr><tr><td> \n";
	print "<table border=0 width=\"80%\" align=center><tr>\n";
	print "<td align=center><strong><u>Qty</u></strong>\n";
	print "</td><td align=center><strong><u>Product\n";
	print "</u></strong></td><td align=center>\n";
	print "<strong><u>Item</u></strong></td>\n";
	print "<td align=center><strong><u>ID</u></strong>\n";
	print "</td><td align=center><strong><u>Price</u>\n";
	print "</strong></td></tr>\n";
	
	$count=0;
	$Total=0;
	$tweight=0;
	
	foreach $all_items (@all_items) {
		($quantity, $product, $item, $id, $price, $weight) = split(/:/ , $all_items);
		if($item){
			print "<tr align=center><td>$quantity</td><td>\n";
			print "$product</td><td>$item</td>\n";
			print "<td>$id</td><td>\$$price each</td></tr>\n";
			my $SubTotal = $quantity * $price;
			my $SubWeight= $weight * $quantity;
			$Total = $Total + $SubTotal;
			$count = $count + $quantity;
			$tweight = $tweight + $SubWeight;
		} #end if
	} #end loop
	print "</table>\n";
	print "</td></tr><tr><td align=center> \n";
	print "You have selected <strong> $count \n";
	print "</strong> items for a total of <strong> \$\n" ;
	#printf() is used as it gives nice formating for 
	#the dollars and cents
	printf("%.2f", $Total);
	print "</strong><br>Total Weight is :<strong>\n";
	printf("%.2f", $tweight);
	print " kg</strong><br></td></tr><tr><td>\n";
	print "<table border=0 width=\"80%\" align=center>\n";
	print "<tr><td align=center>\n";
	print "<hr width=\"100%\" noshade><font size=-1>\n";
	print "<strong>Check your order \n";
	print "before completing the form below.You cannot \n";
	print "make any order adjustments with this screen.\n";
	print "<br>If adjustments are required you will need \n";
	print "to <a href=$scripturl\?action=ViewCart>\n";
	print "return</a> to your order \n";
	print "screen before continuing</strong></font>\n";
	print "</td></tr></table>\n";
	print "</td></tr><tr align=center><td align=center>\n";
	
	&Cout_Html;
	print "</td></tr><tr><td> \n";
	print "<table border=0 width=\"100%\" align=center>\n";
	print "<tr><td align=center>\n";
	print "<hr width=\"100%\"><font size=-1><strong><i><br>\n";
	print "proudly brought to you by : </i></strong></font>\n";
	print "<a href=$website><font size=-1><strong><i> \n";
	print "$domainname</i></strong></font></a></td>\n";
	print "</tr><tr><td align=center><font size=-1>$footer\n";
	print "</font><hr width=\"100%\" noshade>\n";
	print "</td></tr></table></td></tr></table></center> \n";
	print "</body></html>\n";
	exit;
}else #exception if &GetCookies('scart') fails
	{
		print "Content-type: text/html\n\n";
		print "<html><head><title>$titlebar - \n";
		print "No Order Error !</title></head>\n";
		print "<body bgcolor=$pcolor font=$fcolor>\n";
		print "<table width=\"90%\" align=center><tr>\n";
		print "<td bgcolor=$tcolor align=center>\n";
		print "<hr width=\"100%\" noshade>\n";
		print "<font color=$h2colour><H2>$pagehead</H2>\n";
		print "</font><hr width=\"100%\" noshade>\n";
		print "</td></tr><tr><td align=center>\n";
		print "<table border=0 width=\"100%\" align=center>\n";
		print "<tr><td align=center><font color=$h2colour>\n";
		print "<H2>Check Out Error</H2></font>\n";
		print "<hr width=\"100%\">\n";
		print "<font color=$h3colour><H3>You can't view \n";
		print "check out, because you don't have an order !.\n";
		print "</H3></font><hr width=\"100%\">\n";
		print "<font size=-1><strong>This ordering system \n";
		print "uses cookies to keep track of your order.<br>\n";
		print " If you have recently closed your browser, \n";
		print "our cookie was reset and you will need to \n";
		print "replace your order.<br> We apologise in \n";
		print "advance for any inconveniance. <br>If you \n";
		print "believe that you should not have arrived at \n";
		print "this page, please email us at \n";
		print "<a href=\"mailto:$cartmail\?subject=Checkout Error \">\n";
		print " $cartmail</a> immediately </font></strong>\n";
		print "<br><br></td></tr></table></td></tr><tr><td>\n";
		print "<table border=0 width=\"100%\" align=center \n";
		print "bgcolor=$tcolor><tr><td align=center>\n";
		print "<center><hr width=\"100%\">\n";
		print "<a href=$scripturl\?action=ViewCart>\n";
		print "<font size=-1><strong>KEEP ON BROWSING\n";
		print "</strong></font><hr width=\"100%\"></a>\n";
		print "</center></td></tr></table></td></tr><tr><td>\n";
		print "<table border=0 width=\"100%\" align=center>\n";
		print "<tr><td align=center><font size=-1><strong>\n";
		print "<i><br>proudly brought to you by : </i>\n";
		print "</strong></font>\n";
		print "<a href=$website><font size=-1><strong>\n";
		print "<i> $domainname</i></strong></font></a></td>\n";
		print "</tr><tr><td align=center><font size=-1>\n";
		print "$footer</font><hr width=\"100%\" noshade>\n";
		print "</td></tr></table></td></tr></table></center>\n";
		print "</body></html>\n";
		exit;
	}
}

## END CHECK_OUT
#
##############################################################
##################   SUB ROUTINE PRINT_IT  ###################

sub Print_It {
if(&GetCookies('scart')) {

#Here we make a second cookie ( 'Cust' )to store the customer 
#data in. Here is where you would put the basic customer 
#details. Again, the cookie expires when they close out their
# browser or use the 'logout' button. Credit Card details 
#should NOT be included here - lots of security issues!!!
#The implimentation this script uses is to throw the customer
# to a seperate screen if they chose a cc option. See the sub
# routine "CC_Buy" for further details of how the cart 
#processes CC details
 
	my	@cust_items = split(/\|/, $Cookies{'scart'});
	my	$cust_data="$contents{'fname'}" . ":" . "$contents{'lname'}" .":" . "$contents{'saddress'}" .":" . "$contents{'city'}" .":" . "$contents{'state'}" .":" . "$contents{'zip'}" .":" . "$contents{'nation'}" .":" . "$contents{'email'}" .":" . "$contents{'ftype'}" .":" . "$contents{'ptype'}" .":" . "$contents{'comment'}";

if($contents{'fname'}){
	if($contents{'lname'}){
		if($contents{'saddress'}){
			if($contents{'city'}){
				if($contents{'state'}){
					if($contents{'zip'}){
						if($contents{'nation'}){
							if($contents{'email'}){
								if($contents{'ftype'}){
									if($contents{'ptype'}){

#now we need to check if the clients email address is in correct format
#This does NOT check if the email address is valid, just that it is in the correct
# format (eg: something@something.something). 

if($contents{'email'}!~ /\@/) { &bad_email;}
elsif($contents{'email'}!~ /\./) { &bad_email;}
elsif($contents{'email'}=~ /\ /) { &bad_email;}
elsif($contents{'email'}=~ /\)/) { &bad_email;}
elsif($contents{'email'}=~ /\(/) { &bad_email;}
elsif($contents{'email'}=~ /\:/) { &bad_email;}
elsif($contents{'email'}=~ /\//) { &bad_email;}
elsif($contents{'email'}=~ /\\/) { &bad_email;}
elsif($contents{'email'}=~ /\http:/) { &bad_email;}

#to get here, the email address must be in correct format so we continue
	
	print "Content-type: text/html\n";
	&SetCookies('cust',"$cust_data");
	print "\n";
	print "<html><head><title>$titlebar - \n";
	print "Order Confirmation </title></head>\n";
	print "<body bgcolor=\"#FFFFFF\"><center>\n";
	print "<hr width=\"90%\">\n";
	print "<table width=\"90%\" align=center>\n";
	print "<tr><td><center><font color=$h2colour><H2>\n";
	print "$pagehead</H2></font><center><strong><i>\n";
	print "<font size=-1>Online Order Confirmation</font>\n";
	print "</i></strong></center></td></tr><tr><td>\n";
	print "<table width=\"100%\" COLS=3 align=center><tr>\n";
	print "<td colspan=3><hr width=\"100%\"></td></tr><tr>\n";
	print "<td><font size=-1>\n";
	print "<strong>Print Version</strong></font></td>\n";
	print "<td align=center><strong> Final Quote </strong>\n";
	print "</td>\<td align=right><font size=-1><strong>\n";
	print "$date</strong></font></td>\n";
	print "</tr><tr><td colspan=3><hr width=\"100%\"></td></tr>\n";
	print "</table></td></tr><tr><td align=center>\n";
	print "<table width=\"60%\" COLS=3 align=center>\n";
	print "<tr><td><i><strong>\n";
	print "$contents{'fname'} $contents{'lname'}  \n";
	print "$contents{'email'}</strong></i></td></tr>\n";
	print "<tr><td><i><strong>$contents{'saddress'}\n";
	print "</strong></i></td></tr>\n";
	print "<tr><td><i><strong>$contents{'city'}</strong>\n";
	print "</i></td></tr><tr><td><i><strong>\n";
	print "$contents{'state'} $contents{'zip'} \n";
	print "$contents{'nation'}</strong></i></td></table>\n";
	print "</td></tr><tr><td>\n";
	print "<hr width=\"100%\"><strong>Order Details:\n";
	print "</strong><center><table border=0 align=center \n";
	print "width=\"80%\"><tr><td align=center><strong>Qty\n";
	print "</strong></td><td align=center><strong>\n";
	print "Product</strong></td><td align=center><strong>\n";
	print "Item</strong></td><td align=center><strong>ID\n";
	print "</strong></td><td align=center>\n";
	print "<strong>Price</strong></td></tr>\n";
	
	$tweight=0;
	$count=0;
	$Total=0;
	foreach $cust_items (@cust_items){
		($quantity, $product, $item, $id, $price, $weight) = split(/:/ , $cust_items);
		if($quantity > 0){
		print "<tr><td>$quantity</td>\n";
		print "<td>$product</td><td>$item</td>\n";
		print "<td>$id</td><td>\$$price each</td></tr>\n";
		my $SubTotal = $quantity * $price;
		my $SubWeight= $weight * $quantity;
		$Total = $Total + $SubTotal;
		$count = $count + $quantity;
		$tweight= $tweight + $SubWeight;
		} #end if
	} #end loop
	
	print "<tr><td colspan=6><br></td></tr>\n";
	print "</table></td></tr><tr><td></center>\n";
	print "<center>You wish to order <strong> $count";
	print "</strong> items from $company for a total of: \n";
	print "<strong>\$";
	printf("%.2f", $Total);
	print "</strong>\n";
	
	if($usefreight eq "1"){
		if($contents{'ftype'} eq 'Courier'){
			$fcharge=($tweight * $ccost);
		}
		elsif($contents{'ftype'} eq 'Post'){
			$fcharge=($tweight * $pcost);
		}
		elsif($contents{'ftype'} eq 'Pick Up'){
			$fcharge=($tweight * $pucost);
		}
 
	
	my $full_charge= $fcharge + $Total;
	print "<br>The combined weight of your selections \n";
	print "comes to <strong> \n";
	printf("%.2f", $tweight);
	print " kg</strong><br> You selected \"<strong>\n";
	print "$contents{'ftype'}</strong>\" \n";
	print " which comes to a total of <strong>\$ \n";
	printf("%.2f", $fcharge);
	print "</strong><br> Total Order (including freight) \n";
	print "is <strong>\$ \n";
	printf("%.2f", $full_charge);
	print "</strong>\n";
	print "<br>You made the following comment:\n";
	print "<br><strong>$contents{'comment'}</strong>\n";
	}
	
	if($contents{'ptype'} eq Credit){
		&Credit_Card;
	}
	print "<hr width=\"100%\"><center><hr width=\"100%\"><br>\n";
	print "</td></tr><tr><td align=center>\n";
	print "<table border=0 COLS=2 width=\"100%\" align=center>\n";
	print "<tr><td align=center>\n";
	print "<a href=$shopfront><font size=-1><strong>\n";
	print " CONTINUE </strong></font></a></td>\n";
	print "<td align=center>\n";
	print "<a href=$scripturl\?action=MailIt>\n";
	print "<font size=-1><strong> SEND ORDER </strong>\n";
	print "</font></a></td></tr></table>\n";
	print "</td></tr><tr><td align=center>\n";
	print "<hr width=\"100%\">\n";
	print "<table border=0 width=\"100%\" align=center><tr>\n";
	print "<td align=center><br><font size=-1><strong><i>\n";
	print "proudly brought to you by : </i></strong>\n";
	print "</font><a href=$website><font size=-1><strong>\n";
	print "<i> $domainname </i></strong></font></a>\n";
	print "</td></tr><tr><td align=center>\n";
	print "<font size=-1>$footer</font>n";
	print "<hr width=\"100%\" noshade>\n";
	print "</td></tr></table></td></tr></table></center>\n";
	print "</body></html>\n";
	exit;
}else #exception if $contents{'ptype'} fails
	{
		print "Content-type: text/html\n\n";
		print "<html><head><title>$titlebar - \n";
		print "Payment Error !</title></head>\n";
		print "<body bgcolor=$pcolor font=$fcolor><center>\n";
		print "<table border =0 width=\"90%\" align=center>\n";
		print "<tr bgcolor=$tcolor><td align=center>\n";
		print "<hr width=\"100%\" noshade>\n";
		print "<font color=$h2colour><H2>$pagehead</H2>\n";
		print "</font><hr width=\"100%\" noshade></td></tr>\n";
		print "<tr><td align=center><font color=$h2colour><H2>\n";
		print "Payment Type was invalid</H2></font>\n";
		print "<font color=$h3colour><H3>Please hit your \n";
		print "browser's return (back) button to complete \n";
		print "this field</H3></font><br>\n";
		print "<strong>Thank You for your Interest <br><br>\n";
		print "</strong></td></tr><tr><td>\n";
		print "<table border=0 width=\"100%\" \n";
		print "align=center bgcolor=$tcolor><tr>\n";
		print "<td align=center><hr width=\"100%\" noshade>\n";
		print "<font size=-1><strong><i><br>proudly brought \n";
		print "to you by : </i></strong></font>\n";
		print "<a href=$website>\n";
		print "<font size=-1><strong><i> $domainname</i>\n";
		print "</strong></font></a><br>\n";
		print "<font size=-1><strong><i>\n";
		print "$footer</i></strong>\n";
		print "</font><hr width=\"100%\" noshade>\n";
		print "</td></tr></table>\n";
		print "</td></tr></table></center>\n";
		print "</body></html>\n";
		exit;
	}
}else #exception if $contents{'ftype'} fails
	{
		print "Content-type: text/html\n\n";
		print "<html><head><title>$titlebar - \n";
		print "Freight Error !</title></head>\n";
		print "<body bgcolor=$pcolor font=$fcolor><center>\n";
		print "<table border =0 width=\"90%\" align=center>\n";
		print "<tr bgcolor=$tcolor><td align=center>\n";
		print "<hr width=\"100%\" noshade>\n";
		print "<font color=$h2colour><H2>$pagehead</H2>\n";
		print "</font><hr width=\"100%\" noshade></td></tr>\n";
		print "<tr><td align=center><font color=$h2colour><H2>\n";
		print "Freight selection was invalid</H2></font>\n";
		print "<font color=$h3colour><H3>Please hit your \n";
		print "browser's return (back) button to complete \n";
		print "this field</H3></font></p><br>\n";
		print "<strong>Thank You for your Interest <br><br>\n";
		print "</strong></td></tr><tr><td>\n";
		print "<table border=0 width=\"100%\" \n";
		print "align=center bgcolor=$tcolor><tr>\n";
		print "<td align=center><hr width=\"100%\" noshade>\n";
		print "<font size=-1><strong><i><br>proudly brought \n";
		print "to you by : </i></strong></font>\n";
		print "<a href=$website>\n";
		print "<font size=-1><strong><i> $domainname</i>\n";
		print "</strong></font></a><br>\n";
		print "<font size=-1><strong><i>\n";
		print "$footer</i></strong>\n";
		print "</font><hr width=\"100%\" noshade>\n";
		print "</td></tr></table>\n";
		print "</td></tr></table></center>\n";
		print "</body></html>\n";
		exit;
	}
}else  #exception if $contents{'email'} fails
	{
		
		print "Content-type: text/html\n\n";
		print "<html><head><title>$titlebar - \n";
		print "Email Error !</title></head>\n";
		print "<body bgcolor=$pcolor font=$fcolor><center>\n";
		print "<table border =0 width=\"90%\" align=center>\n";
		print "<tr bgcolor=$tcolor><td align=center>\n";
		print "<hr width=\"100%\" noshade>\n";
		print "<font color=$h2colour><H2>$pagehead</H2>\n";
		print "</font><hr width=\"100%\" noshade></td></tr>\n";
		print "<tr><td align=center><font color=$h2colour><H2>\n";
		print "Your Email field was invalid</H2></font>\n";
		print "<font color=$h3colour><H3>Please hit your \n";
		print "browser's return (back) button to complete \n";
		print "this field</H3></font></p><br>\n";
		print "<strong>Thank You for your Interest <br><br>\n";
		print "</strong></td></tr><tr><td>\n";
		print "<table border=0 width=\"100%\" \n";
		print "align=center bgcolor=$tcolor><tr>\n";
		print "<td align=center><hr width=\"100%\" noshade>\n";
		print "<font size=-1><strong><i><br>proudly brought \n";
		print "to you by : </i></strong></font>\n";
		print "<a href=$website>\n";
		print "<font size=-1><strong><i> $domainname</i>\n";
		print "</strong></font></a><br>\n";
		print "<font size=-1><strong><i>\n";
		print "$footer</i></strong>\n";
		print "</font><hr width=\"100%\" noshade>\n";
		print "</td></tr></table>\n";
		print "</td></tr></table></center>\n";
		print "</body></html>\n";
		exit;
	}       
}else #exception if $contents{'nation'} fails
	{
		print "Content-type: text/html\n\n";
		print "<html><head><title>$titlebar - \n";
		print "Country Error !</title></head>\n";
		print "<body bgcolor=$pcolor font=$fcolor><center>\n";
		print "<table border =0 width=\"90%\" align=center>\n";
		print "<tr bgcolor=$tcolor><td align=center>\n";
		print "<hr width=\"100%\" noshade>\n";
		print "<font color=$h2colour><H2>$pagehead</H2>\n";
		print "</font><hr width=\"100%\" noshade></td></tr>\n";
		print "<tr><td align=center><font color=$h2colour><H2>\n";
		print "Your Country details were invalid</H2></font>\n";
		print "<font color=$h3colour><H3>Please hit your \n";
		print "browser's return (back) button to complete \n";
		print "this field</H3></font></p><br>\n";
		print "<strong>Thank You for your Interest <br><br>\n";
		print "</strong></td></tr><tr><td>\n";
		print "<table border=0 width=\"100%\" \n";
		print "align=center bgcolor=$tcolor><tr>\n";
		print "<td align=center><hr width=\"100%\" noshade>\n";
		print "<font size=-1><strong><i><br>proudly brought \n";
		print "to you by : </i></strong></font>\n";
		print "<a href=$website>\n";
		print "<font size=-1><strong><i> $domainname</i>\n";
		print "</strong></font></a><br>\n";
		print "<font size=-1><strong><i>\n";
		print "$footer</i></strong>\n";
		print "</font></font><hr width=\"100%\" noshade>\n";
		print "</td></tr></table>\n";
		print "</td></tr></table></center>\n";
		print "</body></html>\n";
		exit;
	}
}else #exception if $contents{'zip'} fails
	{
		print "Content-type: text/html\n\n";
		print "<html><head><title>$titlebar - \n";
		print "PostCode Error !</title></head>\n";
		print "<body bgcolor=$pcolor font=$fcolor><center>\n";
		print "<table border =0 width=\"90%\" align=center>\n";
		print "<tr bgcolor=$tcolor><td align=center>\n";
		print "<hr width=\"100%\" noshade>\n";
		print "<font color=$h2colour><H2>$pagehead</H2>\n";
		print "</font><hr width=\"100%\" noshade></td></tr>\n";
		print "<tr><td align=center><font color=$h2colour><H2>\n";
		print "Your PostCode/ZIP details were incomplete\n";
		print "</H2></font>\n";
		print "<font color=$h3colour><H3>Please hit your \n";
		print "browser's return (back) button to complete \n";
		print "this field</H3></font></p><br>\n";
		print "<strong>Thank You for your Interest <br><br>\n";
		print "</strong></td></tr><tr><td>\n";
		print "<table border=0 width=\"100%\" \n";
		print "align=center bgcolor=$tcolor><tr>\n";
		print "<td align=center><hr width=\"100%\" noshade>\n";
		print "<font size=-1><strong><i><br>proudly brought \n";
		print "to you by : </i></strong></font>\n";
		print "<a href=$website>\n";
		print "<font size=-1><strong><i> $domainname</i>\n";
		print "</strong></font></a><br>\n";
		print "<font size=-1><strong><i>\n";
		print "$footer</i></strong>\n";
		print "</font><hr width=\"100%\" noshade>\n";
		print "</td></tr></table>\n";
		print "</td></tr></table></center>\n";
		print "</body></html>\n";
		exit;
	}
}else #exception if $contents{'state'} fails
	{
		print "Content-type: text/html\n\n";
		print "<html><head><title>$titlebar - \n";
		print "State Error !</title></head>\n";
		print "<body bgcolor=$pcolor font=$fcolor><center>\n";
		print "<table border =0 width=\"90%\" align=center>\n";
		print "<tr bgcolor=$tcolor><td align=center>\n";
		print "<hr width=\"100%\" noshade>\n";
		print "<font color=$h2colour><H2>$pagehead</H2>\n";
		print "</font><hr width=\"100%\" noshade></td></tr>\n";
		print "<tr><td align=center><font color=$h2colour><H2>\n";
		print "Your State/Province details were incomplete\n";
		print "</H2></font>\n";
		print "<font color=$h3colour><H3>Please hit your \n";
		print "browser's return (back) button to complete \n";
		print "this field</H3></font></p><br>\n";
		print "<strong>Thank You for your Interest <br><br>\n";
		print "</strong></td></tr><tr><td>\n";
		print "<table border=0 width=\"100%\" \n";
		print "align=center bgcolor=$tcolor><tr>\n";
		print "<td align=center><hr width=\"100%\" noshade>\n";
		print "<font size=-1><strong><i><br>proudly brought \n";
		print "to you by : </i></strong></font>\n";
		print "<a href=$website>\n";
		print "<font size=-1><strong><i> $domainname</i>\n";
		print "</strong></font></a><br>\n";
		print "<font size=-1><strong><i>\n";
		print "$footer</i></strong>\n";
		print "</font><hr width=\"100%\" noshade>\n";
		print "</td></tr></table>\n";
		print "</td></tr></table></center>\n";
		print "</body></html>\n";
		exit;
	}
}else #exception if $contents{'city'} fails
	{
		
		print "Content-type: text/html\n\n";
		print "<html><head><title>$titlebar - \n";
		print "City Error !</title></head>\n";
		print "<body bgcolor=$pcolor font=$fcolor><center>\n";
		print "<table border =0 width=\"90%\" align=center>\n";
		print "<tr bgcolor=$tcolor><td align=center>\n";
		print "<hr width=\"100%\" noshade>\n";
		print "<font color=$h2colour><H2>$pagehead</H2>\n";
		print "</font><hr width=\"100%\" noshade></td></tr>\n";
		print "<tr><td align=center><font color=$h2colour><H2>\n";
		print "Your City details were incomplete</H2></font>\n";
		print "<font color=$h3colour><H3>Please hit your \n";
		print "browser's return (back) button to complete \n";
		print "this field</<H3></font></p><br>\n";
		print "<strong>Thank You for your Interest <br><br>\n";
		print "</strong></td></tr><tr><td>\n";
		print "<table border=0 width=\"100%\" \n";
		print "align=center bgcolor=$tcolor><tr>\n";
		print "<td align=center><hr width=\"100%\" noshade>\n";
		print "<font size=-1><strong><i><br>proudly brought \n";
		print "to you by : </i></strong></font>\n";
		print "<a href=$website>\n";
		print "<font size=-1><strong><i> $domainname</i>\n";
		print "</strong></font></a><br>\n";
		print "<font size=-1><strong><i>\n";
		print "$footer</i></strong>\n";
		print "</font><hr width=\"100%\" noshade>\n";
		print "</td></tr></table>\n";
		print "</td></tr></table></center>\n";
		print "</body></html>\n";
		exit;
	}
}else #exception if $contents{'saddress'} fails
	{
		print "Content-type: text/html\n\n";
		print "<html><head><title>$titlebar - \n";
		print "Street Error !</title></head>\n";
		print "<body bgcolor=$pcolor font=$fcolor><center>\n";
		print "<table border =0 width=\"90%\" align=center>\n";
		print "<tr bgcolor=$tcolor><td align=center>\n";
		print "<hr width=\"100%\" noshade>\n";
		print "<font color=$h2colour><H2>$pagehead</H2>\n";
		print "</font><hr width=\"100%\" noshade></td></tr>\n";
		print "<tr><td align=center><font color=$h2colour><H2>\n";
		print "Your Street Address was incomplete</H2></font>\n";
		print "<font color=$h3colour><H3>Please hit your \n";
		print "browser's return (back) button to complete \n";
		print "this field</H3></font></p><br>\n";
		print "<strong>Thank You for your Interest <br><br>\n";
		print "</strong></td></tr><tr><td>\n";
		print "<table border=0 width=\"100%\" \n";
		print "align=center bgcolor=$tcolor><tr>\n";
		print "<td align=center><hr width=\"100%\" noshade>\n";
		print "<font size=-1><strong><i><br>proudly brought \n";
		print "to you by : </i></strong></font>\n";
		print "<a href=$website>\n";
		print "<font size=-1><strong><i> $domainname</i>\n";
		print "</strong></font></a><br>\n";
		print "<font size=-1><strong><i>\n";
		print "$footer</i></strong>\n";
		print "</font><hr width=\"100%\" noshade>\n";
		print "</td></tr></table>\n";
		print "</td></tr></table></center>\n";
		print "</body></html>\n";
		exit;
	}
}else #exception if $contents{'lname'} fails
	{
		print "Content-type: text/html\n\n";
		print "<html><head><title>$titlebar - \n";
		print "Last Name Error !</title></head>\n";
		print "<body bgcolor=$pcolor font=$fcolor><center>\n";
		print "<table border =0 width=\"90%\" align=center>\n";
		print "<tr bgcolor=$tcolor><td align=center>\n";
		print "<hr width=\"100%\" noshade>\n";
		print "<font color=$h2colour><H2>$pagehead</H2>\n";
		print "</font><hr width=\"100%\" noshade></td></tr>\n";
		print "<tr><td align=center><font color=$h2colour><H2>\n";
		print "Your Last Name was incomplete</H2></font>\n";
		print "<font color=$h3colour><H3>Please hit your \n";
		print "browser's return (back) button to complete \n";
		print "this field</H3></font></p><br>\n";
		print "<strong>Thank You for your Interest <br><br>\n";
		print "</strong></td></tr><tr><td align=center>\n";
		print "<table border=0 width=\"100%\" \n";
		print "align=center bgcolor=$tcolor><tr>\n";
		print "<td align=center><hr width=\"100%\" noshade>\n";
		print "<font size=-1><strong><i><br>proudly brought \n";
		print "to you by : </i></strong></font>\n";
		print "<a href=$website>\n";
		print "<font size=-1><strong><i> $domainname</i>\n";
		print "</strong></font></a><br>\n";
		print "<font size=-1><strong><i>\n";
		print "$footer</i></strong>\n";
		print "</font><hr width=\"100%\" noshade>\n";
		print "</td></tr></table>\n";
		print "</td></tr></table></center>\n";
		print "</body></html>\n";
		exit;
	}
}else  #exception if $contents{'fname'} fails
	{
		print "Content-type: text/html\n\n";
		print "<html><head><title>$titlebar - \n";
		print "First Name Error !</title></head>\n";
		print "<body bgcolor=$pcolor font=$fcolor><center>\n";
		print "<table border =0 width=\"90%\" align=center>\n";
		print "<tr bgcolor=$tcolor><td align=center>\n";
		print "<hr width=\"100%\" noshade>\n";
		print "<font color=$h2colour><H2>$pagehead</H2>\n";
		print "</font><hr width=\"100%\" noshade></td></tr>\n";
		print "<tr><td align=center><font color=$h2colour><H2>\n";
		print "Your First Name was incomplete</H2></font>\n";
		print "<font color=$h3colour><H3>Please hit your \n";
		print "browser's return (back) button to complete \n";
		print "this field</H3></font></p><br>\n";
		print "<strong>Thank You for your Interest <br>\n";
		print "</strong></td></tr><tr><td align=center>\n";
		print "<table border=0 width=\"100%\" \n";
		print "align=center bgcolor=$tcolor><tr>\n";
		print "<td align=center><hr width=\"100%\" noshade>\n";
		print "<font size=-1><strong><i><br>proudly brought \n";
		print "to you by : </i></strong></font>\n";
		print "<a href=$website>\n";
		print "<font size=-1><strong><i> $domainname</i>\n";
		print "</strong></font></a><br>\n";
		print "<font size=-1><strong><i>\n";
		print "$footer</i></strong>\n";
		print "</font><hr width=\"100%\" noshade>\n";
		print "</td></tr></table>\n";
		print "</td></tr></table></center>\n";
		print "</body></html>\n";
		exit;
	}
}  #exception if &GetCookies('scart') fails
}

## END PRINT_IT
#
##############################################################
#################   SUB ROUTINE BAD_EMAIL   ##################
sub bad_email{
		
		print "Content-type: text/html\n\n";
		print "<html><head><title>$titlebar - \n";
		print "Email Error !</title></head>\n";
		print "<body bgcolor=$pcolor font=$fcolor><center>\n";
		print "<table border =0 width=\"90%\" align=center>\n";
		print "<tr bgcolor=$tcolor><td align=center>\n";
		print "<hr width=\"100%\" noshade>\n";
		print "<font color=$h2colour><H2>$pagehead</H2>\n";
		print "</font><hr width=\"100%\" noshade></td></tr>\n";
		print "<tr><td align=center><font color=$h2colour><H2>\n";
		print "Your Email field was invalid</H2></font>\n";
		print "<font color=$h3colour><H3>Please hit your \n";
		print "browser's return (back) button to complete \n";
		print "this field</H3></font></p><br>\n";
		print "<strong>Thank You for your Interest <br><br>\n";
		print "</strong></td></tr><tr><td>\n";
		print "<table border=0 width=\"100%\" \n";
		print "align=center bgcolor=$tcolor><tr>\n";
		print "<td align=center><hr width=\"100%\" noshade>\n";
		print "<font size=-1><strong><i><br>proudly brought \n";
		print "to you by : </i></strong></font>\n";
		print "<a href=$website>\n";
		print "<font size=-1><strong><i> $domainname</i>\n";
		print "</strong></font></a><br>\n";
		print "<font size=-1><strong><i>\n";
		print "$footer</i></strong>\n";
		print "</font><hr width=\"100%\" noshade>\n";
		print "</td></tr></table>\n";
		print "</td></tr></table></center>\n";
		print "</body></html>\n";
		exit;
	}   
	    
##	END BAD_EMAIL
#	
##############################################################
#################  SUB ROUTINE CREDIT_CARD  ##################

sub Credit_Card{
	print "<table border=0 width=\"100%\" align=center \n";
	print "cellspacing=0><tr><td align=center>\n";
	print "<form action=$scripturl method=POST>\n";
	print "<input type=hidden name=action value=MailIt>\n";
	print "<p><center><font color=red size=-1><strong><i>  \n";
	print "You have elected to pay by Credit card.\n";
	print "The information requested allows $company to \n";
	print "assist you with the minimum of delay. All \n";
	print "fields are mandatory. That is - the form will \n";
	print "not be processed if you do not complete all \n";
	print "fields !<br>No data collected here is collected\n";
	print "and is nothing stored on our server.\n";
	print "Your details will be forwarded to $buymail at \n";
	print "your discretion</i><br>.If you are not happy \n";
	print "with this setup, select the <strong>NO DETAILS\n";
	print "</strong>.button at the bottom of this form<br>.\n";
	print "Our sales representatives will contact you \n";
	print "shortly to arrange other methods of \n";
	print "transferring your credit card details<br>.\n";
	print "</strong></font></center></p><hr width=\"100%\">\n";
	print "</td></tr><tr><td><table border=0 cols=3 \n";
	print "align=center width=\"100%\">\n";
	print "<tr><td align=right><strong>\n";
	print "Name:</strong></td><td colspan=2 align=left>\n"; 
	print "<input name=cc_name></td></tr>\n";
	print "<tr align=center><td align=right>\n";
	print "<font size=-1><strong> Card: </strong></font>\n";
	print "</td><td colspan=2 align=left><select name=cc_type>\n";
	print "<option value=MasterCard>MasterCard \n";
	print "<option value=VISA>VISA \n";
	print "<option value=Diners>Diners \n";
	print "<option value=AMEX>American Express </select>\n";
	print "</td></tr><tr><td align=right><strong>\n";
	print "<font size=-1>Expires (mm/yy):</font></strong></td><td colspan=2 align=left>\n"; 
	print "<input size=5 name=cc_exp maxlength=5></td></tr>\n";
	print "<tr><td align=right><font size=-1>\n";
	print "<strong>Card Number:</strong></font>\n"; 
	print "</td><td colspan=2>\n";
	print "<input size=20 name=cc_number> \n";
	print "</td></tr><tr><td align=right>\n";
	print "<font size=-1><strong> Verification Number:\n";
	print "</strong></font></td> <td colspan=2 align=left>\n"; 
	print "<input size=3 name=cc_valid maxlength=3></td>\n";
	print "</tr><tr><td colspan=3 align=right>\n";
	print "<table width=\"80%\" align=center><tr>\n";
	print "<td align=center>\n";
	print "<font size=-1><font color=red><strong><i>From 1 \n";
	print "April 2001 Visa and Mastercard require mailorder\n";
	print " credit card transactions to include the 3 \n";
	print "digit card verification code found at the end \n";
	print "of the credit card number on the signature side \n";
	print "of the card.</i></strong></font></font>\n";
	print "</td></tr></table></td></tr>\n";
	print "<tr bgcolor=$tcolor align=center><td colspan=3>\n";
	print "<hr noshade>\n";            
	print "<input type=Submit value=\"Send Order\">\n";
	print "<input type=Reset value=\"Clear Form\"></form>\n";
	print "<form action=$shopfront method=POST>\n";
	print "<input type=hidden name=action>\n";
	print "<input type=Submit value=\"Back to Site\">\n";
	print "<hr noshade></td></tr>\n";
	print "</table></td></tr><tr><td>\n";
	print "<table border=0 width=\"100%\" align=center><tr>\n";
	print "<td align=center><br><font size=-1><strong><i>\n";
	print "proudly brought to you by : </i></strong>\n";
	print "</font><a href=$website><font size=-1><strong>\n";
	print "<i> $domainname </i></strong></font></a></td>\n";
	print "</tr><tr><td align=center><font size=-1>$footer\n";
	print "<hr width=\"100%\" noshade></td></tr></center>\n";
	print "</table></td></tr></table></table></center>\n";
	print "</body></html>\n";
	exit;
}

## END CREDIT_CARD
#
##############################################################
#################  SUB ROUTINE DELETE_ITEM  ##################

#This is to delete single items. It can be called from the 
#ViewCart, CheckOut and itself.

sub Delete_Item {
	
if(&GetCookies('scart')) {
	my @del_array = split(/\|/, $Cookies{'scart'});
	my $KillNumber = $contents{'number'};
	my $del_item = splice(@del_array,$KillNumber,1);


## Had a few problems with this routine and it was resolved until recently. Dave Lewis 
# pointed it out and inspired me to fix it once and for all. Ain't open source
#a wonderful thing ? :)

	foreach $del_array (@del_array) {
	($quantity, $product, $item, $id, $price, $weight) = split(/:/ , $del_array);
	if($ticker ==0){
		$newlist= ("$quantity" .":"."$product" .":" . "$item" .":" . "$id" .":" . "$price" .":" . "$weight");
		$ticker=1;
	} else
	{
	$newlist= ("$newlist"."\|" . "$quantity" .":"."$product" .":" . "$item" .":" . "$id" .":" . "$price" .":" . "$weight");
	}#end if
	} #end loop
	
	my	@deleted = split(/\|/, $del_item);	
	foreach $deleted (@deleted) {
		($dquantity, $dproduct, $ditem, $did, $dprice, $dweight) = split(/:/ , $deleted);
		} #end loop

	print "Content-type: text/html\n";
	&SetCookies('scart',"$newlist");
	print "\n";
	print "<html><head><title>$titlebar - \n";
	print "Item deleted</title></head>\n";	
	print "<body bgcolor=$pcolor font=$fcolor><center>\n";
	print "<table border =0 width=\"90%\" align=center>\n";
	print "<tr bgcolor=$tcolor><td align=center>\n";
	print "<hr width=\"100%\" noshade>\n";
	print "<font color=$h2colour><H2>$pagehead</H2></font>\n";
	print "<hr width=\"100%\" noshade></td></tr>\n";
	print "<tr><td align=center><font color=$h3colour><H3>\n";
	print "Deleted Items</H3></font><br>\n";
	print "You have deleted $dquantity $dproduct $did at \n";
	print "\$$dprice each. \n";
	
	if(scalar(@del_array)>0){
	print "Your current Order is:\n";
	print "</td></tr><tr><td>\n";
	print "<table border=0 width=\"80%\" \n";
	print "align=center><tr><td align=center><strong>\n";
	print "<u>Qty</u></strong></td><td align=center>\n";
	print "<strong><u>Product</u></strong></td>\n";
	print "<td align=center><strong><u>Item</u></strong>\n";
	print "</td><td align=center><strong><u>ID</u></strong>\n";
	print "</td><td align=center><strong><u>Price</u>\n";
	print "</strong></td><td align=center><strong><u>Action\n";
	print "</u></strong></td></tr>";
	
	$RemoveNumber=0;
	$count=0;
	$Total=0;
	$tweight=0;
		
	foreach $del_array (@del_array) {
		($quantity, $product, $item, $id, $price, $weight) = split(/:/ , $del_array);
		if($quantity > 0){
			print "<tr><td align=center>$quantity</td><td \n";
			print "align=center>$product</td>\n";
			print "<td align=center>$item</td>\n";
			print "<td align=center>$id</td>\n";
			print "<td align=center>\$$price each</td>\n";
			print "<td align=center>\n";
			print "<a href=$scripturl\?action=DeleteItem\&number=$RemoveNumber>\n";
			print "<i>Remove</i></a></td></tr>\n";
			my $SubTotal = $quantity * $price;
			my $SubWeight= $weight * $quantity;
			$Total = $Total + $SubTotal;
			$count = $count + $quantity;
			$tweight = $tweight + $SubWeight;
			$RemoveNumber++;
		} #end if
	} #end loop
    
	print "</table>\n";
	print "</td></tr><tr><td align=center><br> You have <strong>\n";
	print "$count</strong> items remaining \n";
	print " for a Total of: <strong>\$ \n";
	printf("%.2f", $Total);
	print "</strong><br>\n";
	print "Total Weight is : <strong>\n";
	printf("%.2f", $tweight);
	print " kg </strong> <br>\n";
	}else #if the "scalar()" test fails, your cart is empty
		{
		print "<br><br><center><font size=+1><strong>Your \n";
		print "Cart is now Empty.</strong>\n";
		print "</font></center><br><hr width=\"100%\">\n";
	}
	print "</td></tr><tr><td align=center>\n";
	print "<table border=0 COLS=3 width= \"100%\" \n";
	print "align=center cellspacing=0 bgcolor=$tcolor>\n";
	print "<tr><td colspan=3><hr width=\"100%\"></td>\n";
	print "</tr><tr align=center>\n";
	print "<td align=right><a href=$shopfront>\n";
	print "<font size=-1><strong> CONTINUE \n";
	print "</strong></font></a></td><td align=center>\n";
	print "<a href=$scripturl\?action=Ccart>\n";
	print "<font size=-1><strong> CLEAR CART </strong>\n";
	print "</font></a></td><td align=left>\n";
	print "<a href=$scripturl\?action=CheckOut>\n";
	print "<font size=-1><strong> CHECK OUT </strong>\n";
	print "</font></a></td></tr><tr><td colspan=3>\n";
	print "<hr width=\"100%\"></td></tr></table></center>\n";
	print "</td></tr><tr><td><table border=0 width=\"100%\">\n";
	print "<tr><td align=center><font size=-1>\n";
	print "<strong><i> proudly brought to you by : </i>\n";
	print "</strong></font><a href=$website><font size=-1>\n";
	print "<strong><i> $domainname</i></strong></font></a>\n";
	print "</td></tr><tr><td align=center><font size=-1>\n";
	print "$footer</font><hr width=\"100%\" noshade></td>\n";
	print "</tr></table></td></tr></table></center>\n";
	print "</body></html>\n";
	exit;
}else #exception if &GetCookies('scart') fails
	{
		print "Content-type: text/html\n\n";
		print "<html><head><title>$titlebar - Order Error !</title></head>\n";
		print "<body bgcolor=$pcolor font=$fcolor><center>\n";
		print "<table width=\"90%\" align=center border=0>\n";
		print "<tr bgcolor=$tcolor><td align=center>\n";
		print "<hr width=\"100%\" noshade>\n";
		print "<font color=$h2colour><H2>$pagehead</H2></font>\n";
		print "<hr width=\"100%\" noshade></td></tr>\n";
		print "<tr><td align=center><font color=$h3colour>\n";
		print "<H3>Cart Error !</H3></font>\n";
		print "<center><strong><font size=+1>You don't seem \n";
		print "to have a cart</font></strong><br></td>\n";
		print "</tr><tr bgcolor=$tcolor><td align=center>\n";
		print "<hr width=\"100%\" NOSHADE>\n";
		print "<a href=$shopfront><strong>Keep on Browsing\n";
		print "</strong></a>\n";
		print "<hr width=\"100%\" NOSHADE></td></tr>\n";
		print "<tr><td align=center>\n";
		print "<table border=0 width=\"100%\" cellspacing=0>\n";
		print "<tr><td align=center>\n";
		print "<hr width=\"100%\" noshade><font size=-1>\n";
		print "<strong><i><br>proudly brought to you by : \n";
		print "</i></strong></font><a href=$website>\n";
		print "<font size=-1><strong>\<i> $domainname</i>\n";
		print "</strong></font></a></td></tr><tr>\n";
		print "<td align=center><font size=-1>$footer\n";
		print "</font><hr width=\"100%\" noshade></td></tr>\n";
		print "</table></td></tr></table></center>\n";
		print "</body></html>\n";
		exit;
	} 
} 

## END DELETE_ITEM
#
##############################################################
################# SUB ROUTINE ADD_ITEM  ######################

#This routine 'fills' the cart - allowing clients to 'add' an 
#item. There are two 'main' screens. One is for the initial 
#purchase, which basically says that they have used the cart 
#for the first time and informs them that the cart uses 
#cookies and some basic security advice
#The second screen gives a list of what is presently in their
# 'scart', with a Grand Total in $$.CC format. All screens have
# links back to the storefront; a 'Clear Cart' link and a 
#'CheckOut' link.There is also a several link to the 
#'delete_items' routine, an email address, a link back to the
#site homepage in the standard 'footer'

sub Add_Item {

if($contents{'quantity'}>"0"){
	
if(&GetCookies('scart')){

	if($Cookies{'scart'}){
	
	my	$addeditem = "$Cookies{'scart'}" . "\|" . "$contents{'quantity'}" . ":" . "$contents{'product'}" . ":" . "$contents{'item'}" . ":" . "$contents{'id'}" . ":" . "$contents{'price'}" . ":" . "$contents{'weight'}";
	my	@newcart = split(/\|/, $addeditem);
     
	print "Content-type: text/html\n";
	&SetCookies('scart',"$addeditem");
	print "\n";
	print "<html><head><title>$titlebar - \n";
	print "Added Item</title></head>\n";
	print "<body bgcolor=$pcolor font=$fcolor><center>\n";
	print "<table border =0 width=\"90%\" align=center>\n";
	print "<tr bgcolor=$tcolor><td align=center>\n";
	print "<hr width=\"100%\" noshade>\n";
	print "<font color=$h2colour><H2>$pagehead</H2></font>\n";
	print "<hr width=\"100%\" noshade></td></tr><tr><td align=center>\n";
	print "<font color=$h3colour><H3>Your Current \n";
	print "Cart</H3></font> You have added \n";
	print "$contents{'quantity'} $contents{'item'} at \n";
	print "\$$contents{'price'} each to your order, Your \n";
	print "current Order is:<br>\n";
	print "</td></tr><tr><td align=center >\n";
	print "<table border=0 align=center width=\"80%\"><tr>\n";
	print "<td align=center><strong><u>Qty</u></strong>\n";
	print "</td><td align=center><strong><u>Product</u>\n";
	print "</strong></td><td align=center><strong><u>Item\n";
	print "</u></strong></td>\n";
	print "<td align=center><strong><u>ID</u></strong></td>\n";
	print "<td align=center><strong><u>Price</u></strong>\n";
	print "</td><td align=center><strong><u>Action</u>\n";
	print "</strong></td></tr>";

	$RemoveNumber=0;
	$count=0;
	$Total=0;
	$tweight=0;
	
	foreach $newcart (@newcart) {
		($quantity, $product, $item, $id, $price, $weight) = split(/:/ , $newcart);
		if($quantity > 0){
			print "<tr><td>  $quantity  </td><td>  $product  \n";
			print "</td><td>  $item  </td><td>  $id  </td>\n";
			print "<td>  \$$price each  </td><td>\n";
			print "<a href=$scripturl\?action=DeleteItem\&number=$RemoveNumber>\n";
			print "<i>  Remove  </i></a></td></tr>\n";
			my $SubTotal = $quantity * $price;
			my $SubWeight= $weight * $quantity;
			$Total = $Total + $SubTotal;
			$count = $count + $quantity;
			$tweight = $tweight + $SubWeight;
			$RemoveNumber++;
		} #end if
	} #end loop
	print "</table></td></tr><tr><td align=center >\n";
	print "<br> You Have Selected <strong>\n";
	printf("%.0f",$count);
	print "</strong> items\n";
	print " for a Total of: <strong>\$ \n";
	printf("%.2f", $Total);
	print "</strong><br>\n";
	print "Total Weight is : <strong>\n";
	printf("%.2f", $tweight);
	print " kg </strong> <br></td></tr><tr><td>\n";
	print "<table border=0 COLS=3 width= \"100%\" \n";
	print "align=center bgcolor=$tcolor cellspacing=0>\n";
	print "<tr><td colspan=3><hr width=\"100%\"></td></tr>\n";
	print "<tr align=center><td align=right>\n";
	print "<a href=$referer><font size=-1><strong>  \n";
	print "CONTINUE </strong></font></a></td>\n";
	print "<td align=center>\n";
	print "<a href=$scripturl\?action=Ccart>\n";
	print "<font size=-1><strong> CLEAR ALL</strong>\n";
	print "</font></a></td><td align=left>\n";
	print "<a href=$scripturl\?action=CheckOut> \n";
	print "<font size=-1><strong>CHECK OUT</strong>\n";
	print "</font></a></td></tr><tr><td colspan=3>\n";
	print "<hr width=\"100%\"></td></tr></table></td>\n";
	print "</tr><tr><td><table border=0 width=\"100%\">\n";
	print "<tr><td align=center><font size=-1>\n";
	print "<strong><i> proudly brought to you by : </i>\n";
	print "</strong></font><a href=$website>\n";
	print "<font size=-1><strong><i> \n";
	print "$domainname</i></strong></font></a></td></tr>\n";
	print "<tr><td align=center><font size=-1>$footer\n";
	print "</font><hr width=\"100%\" noshade></td></tr>\n";
	print "</table></td></tr></table></center>\n";
	print "</body></html>\n";
	exit;

}else 
#an exception if the $Cookies('scart') fails. Basically this means that
#they have a cookie but it is empty (they most likely have deleted all items). This was
#written in in Apr2004 to stop a 'null' line being inserted in the cookie when you
#add new item with the line "$addeditem = "$Cookies{'scart'}" . "\|" . "$contents{'quantity'}"
#etc. Thanks again to Dave Lewis for describing the problem

	{
		&New_Purchase;
	}
}else
#an exception if the &GetCookies('scart') fails - means this is 
#the first time they have used the script this session and so 
#builds them a cart.
	{
		&New_Purchase;
	}
}else		
#Added Jan 2003 - this will show if they forget to indicate
# a quantity to buy

	{
		print "Content-type: text/html\n\n";    
		print "<html><head><title>$titlebar - \n";
		print "No Quantity Error</title></head>\n";
		print "<body bgcolor=$pcolor font=$fcolor><center>\n";
		print "<table border =0 width=\"90%\" align=center>\n";	
		print "<tr bgcolor=$tcolor><td align=center>\n";
		print "<hr width=\"100%\" noshade>\n";
		print "<font color=$h2colour><H2>$pagehead</H2>\n";
		print "</font><hr width=\"100%\" noshade></td></tr>\n";
		print "<tr><td align=center><font color=$h3colour><H3>Sorry !</H3>\n";
		print "</font><h4>You did not indicate how many \n";
		print "items you require</h4><font size=-1><strong>\n";
		print "You need to return to the previous page and  \n";
		print "indicate a quantity you wish to purchase\n";
		print "</strong> <br>If you believe this screen \n";
		print "is an error<br>Please contact us at <strong>\n";
		print "<a href=\"mailto:$cartmail\?subject=No Item Error\">\n";
		print "$cartmail</strong></a> immediately.\n";
		print "</font></strong><br></td></tr><tr><td>\n";
		print "<table border=0 COLS=3 width= \"100%\" \n";
		print "align=center bgcolor=$tcolor cellspacing=0>\n";
		print "<tr><td colspan=3><hr width=\"100%\"></td>\n";
		print "</tr><tr><td align=right><a href=$shopfront>\n";
		print "<font size=-1><strong>  CONTINUE \n";
		print "</strong></font></a></td><td align=center>\n";
		print "<a href=$scripturl\?action=Ccart>\n";
		print "<font size=-1><strong> CLEAR CART </strong>\n";
		print "</font></a></td><td align=left>\n";
		print "<a href=$scripturl\?action=CheckOut>\n";
		print "<font size=-1><strong> CHECK OUT </strong>\n";
		print "</font></a></td></tr><tr><td colspan=3>\n";
		print "<hr width=\"100%\"></td></tr></table></td>\n";
		print "</tr><tr><td><table border=0 width=\"100%\">\n";
		print "<tr><td align=center><font size=-1><strong>\n";
		print "<i>proudly brought to you by : </i></strong>\n";
		print "</font><a href=$website><font size=-1>\n";
		print "<strong><i> $domainname</i></strong></font>\n";
		print "</a></td></tr><tr><td align=center>\n";
		print "<font size=-1>$footer</font>\n";
		print "<hr width=\"100%\" noshade></td></tr></table>\n";
		print "</td></tr></table></center>\n";
		print "</body></html>\n";
		exit;
	}
}

## END ADD_ITEM
#
##############################################################
################  SUB ROUTINE NEW_PURCHASE   #################
sub New_Purchase {

	my	$newitem = "$contents{'quantity'}" . ":" . "$contents{'product'}" .":" . "$contents{'item'}" . ":" . "$contents{'id'}" . ":" . "$contents{'price'}" . ":" . "$contents{'weight'}";
	print "Content-type: text/html\n";
	&SetCookies('scart',"$newitem");
	print "\n";      
	print "<html><head><title>$titlebar - \n";
	print "First Item added</title></head>\n";
	print "<body bgcolor=$pcolor font=$fcolor><center>\n";
	print "<table border =0 width=\"90%\" align=center>\n";
	print "<tr bgcolor=$tcolor><td align=center>\n";
	print "<hr width=\"100%\" noshade>\n";
	print "<font color=$h2colour><H2>$pagehead</H2>\n";
	print "</font><hr width=\"100%\" noshade></td></tr>\n";
	print "<tr><td align=center><font color=$h2colour><H2>Welcome !\n";
	print "</H2></font><font color=$h3colour><H3>You \n";
	print "have just created a new $titlebar</H3></font>\n";
	print "<hr width=\"100%\"></td></tr><tr><td align=center>\n";
	print "Your current order is: \n";
	print "<strong>$contents{'quantity'} \n";
	print "$contents{'item'}</strong> at <strong>\n";
	print "\$$contents{'price'} each </strong>\n";
   
	my	$NewQuantity = $contents{'quantity'};
	my	$NewPrice = $contents{'price'};
	my	$NewTotal = $NewQuantity * $NewPrice;
	print "<p>Your total is <strong>\$";
	printf("%.2f", $NewTotal);
	
	print "</strong></td></tr><tr><td align=center>\n";
	print "<hr width=\"100%\">\n";
	print "<font size=+1><font color=red><strong>\n";
	print "Do Not Reload Your Browser !</font>\n";
	print "</font><br>Our $titlebar uses cookies to \n";
	print "track your purchases <br> The cookie will be \n";
	print "automatically deleted when you close your \n";
	print "browser<br>No data is sent until you email \n";
	print "your order</strong><br><font size=-1>\n";
	print "<font color=red><i>If you are using a \n";
	print "'public' machine, be sure to close your \n";
	print "browser before leaving the machine unattended\n";
	print "</i></font></font></td></tr><tr><td align=center>\n";
	print "<table border=0 COLS=3 width= \"100%\" \n";
	print "align=center bgcolor=$tcolor cellspacing=0>\n";
	print "<tr><td colspan=3><hr width=\"100%\"></td>\n";
	print "</tr><tr align=center><td align=right>\n";
	print "<a href=$referer><font size=-1>\n";
	print "<strong>  CONTINUE </strong></font>\n";
	print "</a></td><td align=center>\n";
	print "<a href=$scripturl\?action=CheckOut>\n";
	print "<font size=-1><strong> CHECK OUT </strong>\n";
	print "</font></a></td></font></a></td>\n";
	print "<td align=left>\n";
	print "<a href=$scripturl\?action=Ccart>\n";
	print "<font size=-1><strong> CLEAR ALL </strong>\n";
	print "</font></a></td></tr><tr><td colspan=3>\n";
	print "<hr width=\"100%\"></td></tr></table>\n";
	print "</td></tr><tr><td>\n";
	print "<table border=0 width=\"100%\" align=center>\n";
	print "<td align=center><font size=-1><strong><i>\n";
	print "proudly brought to you by : </i></strong>\n";
	print "</font><a href=$website><font size=-1>\n";
	print "<strong><i> $domainname</i></strong></font>\n";
	print "</a></td></tr><tr><td align=center>\n";
	print "<font size=-1>$footer</font>\n";
	print "<hr width=\"100%\" noshade></td></tr></table>\n";
	print "</td></tr></table></center>\n";
	print "</body></html>\n";
	exit;

}
## END NEW_PURCHASE
#
##############################################################
##################  SUB ROUTINE COUT_HTML  ###################
#The following sub-routine is the input form for customer 
#details when they want to "checkout". Called by
#the Check_Out sub-routine

sub Cout_Html {
	print "<table border=0 width=\"100%\" align=center \n";
	print "cellspacing=0><tr><td align=center>\n";
	print "<form action=$scripturl method=POST>\n";
	print "<input type=hidden name=action value=PrintIt>\n";
	print "<font color=red size=-1><strong><i>\n";
	print "Before you can submit your order, you will \n";
	print "need to fill in some personal details.\n";
	print "The information requested allows $company to \n";
	print "assist you with the \n";
	print "minimum of delay. All fields are mandatory\n";
	print "That is - the form will not be processed if \n";
	print "you do not complete all fields ! All data \n";
	print "collected here is collected in a cookie on your \n";
	print "machine and not stored on our server. \n";
	print "At the end of your session (ie: when you \n";
	print "mail your order, 'logout' or close your browser)\n";
	print " all cookies are deleted.</i></strong></font>\n";
	print "<hr width=\"90%\"></td></tr></table>\n";
	print "<table border=0 cols=6 align=center width=\"100%\"\n";
	print "cellspacing=0><tr><td></td><td align=right><font size=-1><strong>\n";
	print "First name:</strong></font></td><td>\n";
	print "<input type=text name=fname></td>\n";
	print "<td align=right><font size=-1><strong>Last name:\n";
	print "</strong></font></td><td>\n";
	print "<input type=text name=lname></td><td></td></tr>\n";
	print "<tr><td></td><td align=right><font size=-1><strong>\n";
	print "Postal Address:* </strong></font></td>\n";
	print "<td colspan=3><input type=text size=65 \n";
	print "name=saddress></td><td></td></tr><tr>\n";
	print "<td></td><td colspan=4 align=center>\n";
	print "<font size=-2><strong> \n";
	print " *NOTE: This is the address where you want\n";
	print " the items delivered to. It must be a <i>street\n";
	print "</i> address</strong></font>\n";
	print "</td><td></td></tr><tr><td></td><td align=right>\n";
	print "<font size=-1><strong>City: </strong></font>\n";
	print "</td><td><input type=text name=city></td>\n";
	print "<td align=right><font size=-1><strong> State:\n";
	print "</strong></font></td><td>\n";
	print "<input type=text name=state></td><td></td></tr>\n";
	print "<tr><td></td><td align=right><font size=-1><strong>\n";
	print "Postal Code/Zip: </strong></font></td><td>\n";
	print "<input type=text name=zip></td>\n";
	print "<td align=right><font size=-1><strong>Country: \n";
	print "</strong></font></td><td>\n";
	print "<input type=text name=nation></td>\n";
	print "<td></td></tr><tr><td></td><td align=right><font size=-1><strong>\n";
	print "E-mail: </strong></font></td><td colspan=3>\n";
	print "<input type=text size=65 name=email>\n";
	print "</td><td></td></tr><tr><td></td><td align=right>\n";
	print "<font size=-1><strong>Freight Type:</strong>\n";
	print "</font></td><td><select name=ftype>\n";
	print "<option value=\"\"> <option value=\"Courier\">\n";
	print "Courier <option value=\"Post\">\n";
	print "Post<option value=Pick Up>\"Pick Up\"</select></td>\n";
	print "<td align=right><font size=-1><strong>Payment \n";
	print "Type: </strong></font></td><td>\n";
	print "<select name=ptype><option value=\"\"> \n";
	print "<option value=Credit>\n";
	print "Credit<option value=Transfer>\n";
	print "Transfer<option value=Cheque>Cheque</select>\n";
	print "</td><td></td></tr>\n";
	print	"<tr><td></td><td align=right><font size=-1><strong>\n";
	print "Comments:</strong></font></td><td colspan=3>\n";
	print "<textarea name=comment rows=3 cols=50>\n";
	print "</textarea></td><td></td></tr>\n"; 
	print "<tr bgcolor=$tcolor align=center><td colspan=6>\n";
	print "<hr noshade>\n";                     
	print "<input type=Submit value=\"Check Out\">\n";
	print "<input type=Reset value=\"Clear Form\"></form>\n";
	print "<form action=$shopfront method=POST>\n";
	print "<input type=hidden name=action>\n";
	print "<input type=Submit value=\"More Shopping\">\n";
	print "<hr width=\"100%\" noshade></td></tr>\n";
	print "</table>\n";
}

## END COUT_HTML
#
##############################################################
#################  SUB ROUTINE PARSE_INPUT  ##################

#A standard perl input parser - needed for the form input

sub parse_input
{
 read(STDIN, $input, $ENV{'CONTENT_LENGTH'});

	$input = $ENV{'QUERY_STRING'} if $ENV{'QUERY_STRING'};

	@pairs = split(/&/, $input);

	foreach $pair (@pairs) {
	($name, $value) = split(/=/, $pair);

	$value =~ tr/+/ /;
	$value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C",hex($1))/eg;

	$contents{$name} = $value;
 }
}

## END PARSE_INPUT
#
##########################  EOF  ############################
#############################################################
#############################################################